namespace sGUI

declare function AddEditDisplay (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer,GadHeight as integer,Mode as integer=0) as Gadget ptr
declare function EDD_Actions(gad as Gadget ptr,action as integer) as integer
declare sub EDD_Draw(gad as Gadget ptr)

declare sub HScrollEditDisplay(gad as Gadget ptr,position as integer)
declare sub VScrollEditDisplay(gad as Gadget ptr,row as integer)
declare function TraceCursorPosition(gad as Gadget ptr) as integer
declare function TraceCursorRow(gad as Gadget ptr) as integer

/'
type EDD_Data
	Mode					    as integer
	CharsPerWidth     as integer'Anzeigebezogen: Wieviel Zeichen einer Zeile passen in die Breite der pixeldefinierten Box
	RowsPerHeight     as integer'Anzeigebezogen: Wieviel Zeilen passen in die Hhe der pixeldefinerten Box
	GapHorizontal			as integer
	GapVertical				as integer
	ScrollRow					as integer
	ScrollPosition		as integer
	CursorVisibility	as integer
end type
'/
function AddEditDisplay (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer,GadHeight as integer,Mode as integer=0) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
	if win=0 then win=RootWindow
	gad=win->GadgetList->AppendNew (GadgetType)
	if gad then
		gad->parent=win
		gad->PosX=PosX
		gad->PosY=PosY
		gad->GadWidth=GadWidth
		gad->GadHeight=GadHeight
    
    gad->xtd.edd.CharsPerWidth=int((GadWidth - 2*LeastGap)/GetFixedWidth)
    if Mode<2 then
      gad->xtd.edd.RowsPerHeight=int((GadHeight - 2*LeastGap)/GetFontHeight(1)) 		
    else
      gad->xtd.edd.RowsPerHeight=1
    end if       
    gad->xtd.edd.GapHorizontal=int( (GadWidth  - gad->xtd.edd.CharsPerWidth*GetFixedWidth) /2)
    gad->xtd.edd.GapVertical=int( (GadHeight  - gad->xtd.edd.RowsPerHeight*GetFontHeight(1)) /2)
    gad->xtd.edd.ScrollPosition=1
    gad->xtd.edd.ScrollRow=1
		gad->xtd.edd.Mode=Mode
		if (Mode=0) or (Mode=2) then
			gad->xtd.edd.CursorVisibility=1
		else
			gad->xtd.edd.CursorVisibility=0
		end if

		'gad->xtd.TContainer=TContainer
    gad->xtd.TContainer=TextList->AppendNew(sGUITextType)
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight,0,32)'by Haubitze
		gad->DoDraw     =@EDD_Draw
		gad->DoAction   =@EDD_Actions
		function=gad
	end if
end function


function EDD_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
	dim as integer GadX,GadY,OffsetLeft,OffsetTop
  dim as integer SelectedRow,CursorPosition,NumRows,RowContentLength
  dim as string RowContent	 
  GetGlobalPosition(gad,GadX,GadY)
	OffsetLeft=gad->xtd.edd.GapHorizontal
	OffsetTop=gad->xtd.edd.GapVertical  
		
	select case action
    case GADGET_LMBHIT        'Control grad frisch gedrckt
      function=-1
      NumRows=gad->xtd.TContainer->GetNumRows
      if NumRows then
        SelectedRow=-1
        CursorPosition=-1
        if MOUSEY>=GadY+OffsetTop and MOUSEY<GadY + gad->GadHeight-OffsetTop then
          SelectedRow=gad->xtd.edd.ScrollRow + int((MOUSEY-GadY-OffsetTop)/GetFontHeight(1))
          if SelectedRow>NumRows then SelectedRow=NumRows
          RowContent=gad->xtd.TContainer->GetRowContent(SelectedRow)
          RowContentLength=len(RowContent)
        end if

        if MOUSEX>=GadX+OffsetLeft and MOUSEX<GadX + gad->GadWidth-OffsetLeft then
          'if (gad->xtd.edd.Mode=0) or (gad->xtd.edd.Mode=2) then
            CursorPosition=gad->xtd.edd.ScrollPosition + int((MOUSEX-GadX-OffsetLeft + GetFixedWidth/2 )/GetFixedWidth)
            'CursorPosition=gad->xtd.edd.ScrollPosition + int((MOUSEX-GadX-OffsetLeft)/GetFixedWidth)
            if CursorPosition>RowContentLength then CursorPosition=RowContentLength+1
          'end if
        end if

        if (SelectedRow<>-1) and (CursorPosition<>-1) then
          gad->xtd.TContainer->SetCursor(SelectedRow,CursorPosition)
        end if
      end if
  end select
end function


sub EDD_Draw (gad as Gadget ptr)
	dim as FB.Image ptr buffer
	dim as integer GadX,GadY,GadWidth,GadHeight,OffsetLeft,OffsetTop	
	dim as integer LineCounter
	dim as integer ScrollLine,ScrollPosition,CursorLine,CursorPosition,CursorVisible
	dim as TextRow ptr LineAddr	
	dim as string TmpLine
	GetGlobalPosition(gad,GadX,GadY)
	GadWidth =gad->GadWidth
	GadHeight=gad->GadHeight
	OffsetLeft=gad->xtd.edd.GapHorizontal
	OffsetTop=gad->xtd.edd.GapVertical	
	Buffer=gad->DrawBuffer->img 
	
	ScrollLine=gad->xtd.edd.ScrollRow
	ScrollPosition=gad->xtd.edd.ScrollPosition
  CursorLine=gad->xtd.TContainer->GetCursorRow
  CursorPosition=gad->xtd.TContainer->GetCursorPosition	
	LineAddr=gad->xtd.TContainer->GetRowAddress(ScrollLine) 	
	TmpLine=""
'OFF
  ClearBox Buffer,0,0,GadWidth,GadHeight
'ON
  if gad->Activation then
	
		select case gad->xtd.edd.Mode
      case 0'Edit EditBox
				FilledBoxList Buffer,0,0,GadWidth,GadHeight,,Colors.EBX_BackGround,1,0    
			case 1,3'View EditBox/StringGadget
        FilledBoxList Buffer,0,0,GadWidth,GadHeight,,Colors.BackGround,1,0
			case 2'Edit StringGadget
        FilledBoxList Buffer,0,0,GadWidth,GadHeight,Colors.EBX_BackGround,Colors.EBX_BackGround,0,0
				FilledBoxList Buffer,1,1,GadWidth-2,GadHeight-2,Colors.EBX_BackGround,Colors.EBX_BackGround,1,0          
    end select
		
		if gad->xtd.TContainer->GetNumRows then		
			LineCounter=0
			do
				TmpLine=gad->xtd.TContainer->GetRowContent (LineAddr)		
        if ScrollPosition>len(TmpLine) then'Wenn der Zeichenoffset grer ist als Zeilenlnge(Horizontalscrolling)
          TmpLine=""
        else
          TmpLine=mid(TmpLine, ScrollPosition, gad->xtd.edd.CharsPerWidth)
        end if
				
				drawstring Buffer, OffsetLeft, OffsetTop+LineCounter*GetFontHeight(1),TmpLine,Colors.EBX_Pen,1			
							
				LineAddr=LineAddr->nextrow
        LineCounter +=1		
			loop until (LineAddr=0) or (LineCounter=gad->xtd.edd.RowsPerHeight)						
		end if

		if (gad->xtd.edd.CursorVisibility=1) and (gad->selection=1) then
			if gad->xtd.TContainer->GetNumRows>0 then
        ClearBox Buffer, _
          OffsetLeft+(CursorPosition-ScrollPosition)*GetFixedWidth-1, _
          OffsetTop+(CursorLine - ScrollLine)*GetFontHeight(1), _
          2,GetFontHeight(1),Colors.EBX_Cursor          
      else
        ClearBox Buffer,OffsetLeft,OffsetTop,2,GetFontHeight(1),Colors.EBX_Cursor           
      end if
		end if		
			
'SLEEP
    if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
  end if
end sub


sub HScrollEditDisplay(gad as Gadget ptr,position as integer)
  gad->xtd.edd.ScrollPosition=position
  gad->ReDraw=1
end sub


sub VScrollEditDisplay(gad as Gadget ptr,row as integer)
  gad->xtd.edd.ScrollRow=row
  gad->ReDraw=1
end sub


function TraceCursorPosition(gad as Gadget ptr) as integer
  dim as integer CursorPos=gad->xtd.TContainer->GetCursorPosition
  if CursorPos < gad->xtd.edd.ScrollPosition then gad->xtd.edd.ScrollPosition=CursorPos 
  if (CursorPos - gad->xtd.edd.ScrollPosition) >= gad->xtd.edd.CharsPerWidth-1 then gad->xtd.edd.ScrollPosition= (CursorPos - (gad->xtd.edd.CharsPerWidth-1))
  if gad->xtd.edd.ScrollPosition<1 then gad->xtd.edd.ScrollPosition=1 
  gad->ReDraw=1
  function=gad->xtd.edd.ScrollPosition
end function


function TraceCursorRow(gad as Gadget ptr) as integer
  dim as integer CursorRow,NumRows
  CursorRow=gad->xtd.TContainer->GetCursorRow
  if CursorRow < gad->xtd.edd.ScrollRow then gad->xtd.edd.ScrollRow=CursorRow 
  if (CursorRow - gad->xtd.edd.ScrollRow) >= gad->xtd.edd.RowsPerHeight-1 then gad->xtd.edd.ScrollRow=(CursorRow - (gad->xtd.edd.RowsPerHeight-1))
  if gad->xtd.edd.ScrollRow<1 then gad->xtd.edd.ScrollRow=1
  gad->ReDraw=1
  function=gad->xtd.edd.ScrollRow
end function

end namespace
