#include once "Gadget_ListBox_Selector.bas"
#include once "Gadget_ScrollBar.bas"

namespace sGUI

declare function AddListBox (win as sGUIWindow ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,DisplayMode as integer=0,SelectionMode as integer=0) as Gadget ptr
declare function LBX_Actions(gad as Gadget ptr,action as integer) as integer
declare sub LBX_Update(gad as Gadget ptr)

declare function GetListBox(gad as Gadget ptr, index as integer=0) as integer
declare function SetListBox(gad as Gadget ptr,i as integer,Selection as integer=1) as integer
/'
'ListBox
type LBX_Data
	DisplayMode	      as integer
	SelectionMode     as integer	
	NumEntriesRef			as integer
  TimeStamp         as double
	selector				  as _Gadget ptr
	scrollbar					as _Gadget ptr	
end type
'/
function AddListBox(win as sGUIWindow ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,DisplayMode as integer=0,SelectionMode as integer=0) as Gadget ptr
  function=0
  dim as Gadget ptr gad
  if win=0 then win=RootWindow
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->Selection=0
    gad->Activation=0
    gad->PosX=PosX
    gad->PosY=PosY
    gad->GadWidth=BoxWidth
    gad->GadHeight=BoxHeight
    gad->xtd.lbx.DisplayMode=DisplayMode
    gad->xtd.lbx.SelectionMode=SelectionMode		

    gad->GadgetWindow=AddWindow(gad,0,0,gad->GadWidth,gad->GadHeight,,) 
    if gad->GadgetWindow then
      
      gad->xtd.lbx.selector	    =AddListBoxSelector(gad->GadgetWindow,0,0,BoxWidth-(MainWidth+1),BoxHeight,DisplayMode,SelectionMode)
      gad->xtd.lbx.scrollbar		=AddScrollBar(gad->GadgetWindow,BoxWidth-MainWidth,0,BoxHeight,1,1,1,1,1)			
    end if
		
    gad->xtd.EntryList =gad->xtd.lbx.selector->xtd.EntryList'Listenzeiger aus Selector holen und in die ListBox kopieren

		
    gad->DoAction   =@LBX_Actions
    gad->DoUpdate   =@LBX_Update
    
		function=gad
  end if
end function


function LBX_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
	dim as integer WheelSensorX,WheelSensorY
  
  select case action
    case GADGET_WHEELMOVE
      GetGlobalPosition(gad->xtd.lbx.selector,WheelSensorX,WheelSensorY)
      if (MOUSEX>=WheelSensorX) and (MOUSEX<WheelSensorX + gad->xtd.lbx.selector->GadWidth) and _
         (MOUSEY>=WheelSensorY) and (MOUSEY<WheelSensorY + gad->xtd.lbx.selector->GadHeight) then
        SetScrollBar(gad->xtd.lbx.scrollbar,GetScrollBar( gad->xtd.lbx.scrollbar ) + WHEEL )'oder WHEEL*(Listbox->xtd.lbx.Flags-1)
        VScrollLBS(gad->xtd.lbx.selector,GetScrollBar(gad->xtd.lbx.scrollbar))
        gad->ReDraw=1
      end if     
   
    case GADGET_LOOPTHROUGH
      if GADGETMESSAGE then       
        select case GADGETMESSAGE
          case gad->xtd.lbx.selector
            function=1
            gad->ReDraw=1
          case gad->xtd.lbx.scrollbar
            VScrollLBS(gad->xtd.lbx.selector,GetScrollBar(gad->xtd.lbx.scrollbar))
            gad->ReDraw=1
        end select
      end if
    
    case GADGET_MOUSEHOVER
      gad->MouseHover=1       
    
    case GADGET_MOUSENEXT
      gad->MouseHover=0      
  end select
end function


sub LBX_Update(gad as Gadget ptr)
  dim as sGUIList ptr EList
	dim as sGUIEntry ptr entry
  dim as integer TotalNumRows	
	EList=gad->xtd.EntryList
  TotalNumRows=EList->NumNodes
	
  if gad->xtd.lbx.TimeStamp <> gad->xtd.EntryList->GetTimeStamp then
		gad->xtd.lbx.NumEntriesRef=TotalNumRows
    if (gad->xtd.lbx.selector->xtd.lbs.SelectedRow>TotalNumRows) or (gad->xtd.lbx.selector->xtd.lbs.SelectedRow<1) then gad->xtd.lbx.selector->xtd.lbs.SelectedRow=0   
		SetScrollBar(gad->xtd.lbx.scrollbar,1,TotalNumRows,1,gad->xtd.lbx.selector->xtd.lbs.NumRows)
    VScrollLBS(gad->xtd.lbx.selector,1)
    gad->xtd.lbx.TimeStamp = gad->xtd.EntryList->GetTimeStamp
    gad->xtd.lbx.selector->ReDraw=1
  end if
end sub


function GetListBox(gad as Gadget ptr,index as integer=0) as integer
  dim as sGUIList ptr EList
	dim as sGUIEntry ptr entry
  dim as integer result
  
	EList=gad->xtd.EntryList
  if index=0 then 
    entry=EList->GetFirst  
  else                                'haben wir einen Index als Startpunkt fr fortgesetzte Suche bergeben
    entry=GetEntryAddr(EList,index)   'dessen Adresse holen
    if entry=Elist->GetLast then      'sollte dieser der letzte der Liste sein
      entry=0                         'braucht nicht weitergesucht werden
    else                              'ist er nicht der letzte Eintrag in der Liste
      'entry=GetEntryAddr(EList,index+1)'seinen Nachfolger als Suchbeginn definieren
      entry=cast(sGUIEntry ptr,entry->next_node)'oder Nachfolger via DLL
    end if
  end if
  
  index=0
  
  if entry then
    do
      if entry->Selection then index=entry->index 
      entry=cast(sGUIEntry ptr,entry->next_node)
    loop until (entry=0) or (index<>0)
  end if
  
  function=index
end function


function SetListBox(gad as Gadget ptr,i as integer,Selection as integer=1) as integer   
  dim as sGUIList ptr EList
	dim as sGUIEntry ptr entry	
	EList=gad->xtd.EntryList
  
  gad->xtd.lbx.selector->ReDraw=1   
  entry=GetEntryAddr(EList,i)
  if entry then
     function=1
     select case gad->xtd.lbx.SelectionMode
        case 0 'single select
          if Selection then
            UnselectEntryList(EList)
            entry->Selection=Selection
            gad->xtd.lbx.selector->xtd.lbs.SelectedRow=entry->Index
            SetScrollBar(gad->xtd.lbx.scrollbar,gad->xtd.lbx.selector->xtd.lbs.SelectedRow)
            VScrollLBS(gad->xtd.lbx.selector,GetScrollBar(gad->xtd.lbx.scrollbar))
          end if
  
        case 1'single deselectable
          if (entry->Selection)=1 then
            entry->Selection=Selection          
          else
            if Selection=1 then
              UnselectEntryList(EList)
              entry->Selection=1
              SetScrollBar(gad->xtd.lbx.scrollbar,gad->xtd.lbx.selector->xtd.lbs.SelectedRow)
              VScrollLBS(gad->xtd.lbx.selector,GetScrollBar(gad->xtd.lbx.scrollbar))
            end if
          end if      				            
       
        case 2'multi deselectable 
          entry->Selection=Selection              
          
      end select   
  else
    function=0
  end if
end function

end namespace
