namespace sGUI

declare function AddListBoxSelector (win as sGUIWindow ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,DisplayMode as integer=0,SelectionMode as integer=0) as Gadget ptr
declare function LBS_Actions(gad as Gadget ptr,action as integer) as integer
declare sub LBS_Draw(gad as Gadget ptr)
declare sub LBS_Update(gad as Gadget ptr)
declare sub VScrollLBS(gad as Gadget ptr,ScrollRow as integer)
declare sub UnselectEntryList(EList as sGUIList ptr)
/'
type LBS_Data
	DisplayMode	      as integer
	SelectionMode     as integer
	NumCharsPerRow		as integer
	NumRows						as integer
	GapHorizontal			as integer
	GapVertical				as integer
	TopRow						as integer	
	SelectedRow				as integer
  HoveredRow        as integer
  oldHoveredRow     as integer
end type
'/
function AddListBoxSelector (win as sGUIWindow ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,DisplayMode as integer=0,SelectionMode as integer=0) as Gadget ptr
  function=0  
  dim as Gadget ptr gad
  if win=0 then win=RootWindow
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->PosX=PosX
    gad->PosY=PosY
    'gad->xtd.lbs.NumCharsPerRow=int((BoxWidth-2*LeastGap)/GetFixedWidth)
    'gad->xtd.lbs.GapHorizontal=int( (BoxWidth  - gad->xtd.lbs.NumCharsPerRow*GetFixedWidth) /2)   
    gad->xtd.lbs.GapHorizontal=LeastGap    
    
    gad->xtd.lbs.NumRows=int((BoxHeight-2*LeastGap)/GetFontHeight(0))   
    gad->xtd.lbs.GapVertical=int( (BoxHeight - gad->xtd.lbs.NumRows*GetFontHeight(0)) /2)
    
    gad->GadWidth=BoxWidth
    gad->GadHeight=BoxHeight
    gad->xtd.lbs.TopRow=1
    gad->xtd.lbs.DisplayMode=DisplayMode
    gad->xtd.lbs.SelectionMode=SelectionMode
    gad->xtd.lbs.SelectedRow=0
		gad->xtd.EntryList	=EntryLists->AppendNew(sGUIListType)
	 
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight,0,32)'by Haubitze 
    gad->DoDraw     =@LBS_Draw
    gad->DoAction   =@LBS_Actions
    gad->DoUpdate		=@LBS_Update    
		function=gad
  end if
end function


function LBS_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
  dim as integer SelectedRow,TotalNumRows,OffsetLeft,OffsetTop,enable
	dim as integer GadX,GadY,GadMousePos
	dim as sGUIList ptr EList=gad->xtd.EntryList  
  dim as sGUIEntry ptr entry
	GetGlobalPosition(gad,GadX,GadY)
	OffsetLeft          =gad->xtd.lbs.GapHorizontal
	OffsetTop           =gad->xtd.lbs.GapVertical

  TotalNumRows=EList->NumNodes
  gad->xtd.lbs.oldHoveredRow=gad->xtd.lbs.HoveredRow
  if (TotalNumRows>0) and (gad->Activation=1) then
    if (MOUSEX>=GadX+OffsetLeft) and (MOUSEX<GadX + gad->GadWidth-OffsetLeft) and _
       (MOUSEY>=GadY+OffsetTop) and (MOUSEY<GadY + gad->GadHeight-OffsetTop) then _
        gad->xtd.lbs.HoveredRow=gad->xtd.lbs.TopRow + int((MOUSEY-GadY-OffsetTop)/GetFontHeight(0))
        if gad->xtd.lbs.HoveredRow<1 then gad->xtd.lbs.HoveredRow=0
        if gad->xtd.lbs.HoveredRow>TotalNumRows then gad->xtd.lbs.HoveredRow=0
  else
      gad->xtd.lbs.HoveredRow=0
    'end if
  end if  
    
  select case action
    case GADGET_LMBHIT        'Control grad frisch gedrckt
      
      SelectedRow=gad->xtd.lbs.HoveredRow
      if SelectedRow>0 then 
        entry=GetEntryAddr(EList,SelectedRow)
        if (gad->xtd.lbs.DisplayMode=3) and (Entry->EntryType=ETYPE_LABEL)  then enable=0 else enable=1 
        
        if enable then
          select case gad->xtd.lbs.SelectionMode
    
            case 0'single select
              if SelectedRow>0 then
                UnselectEntryList(EList)
                entry->Selection=1      				            
                function=1
              end if

            case 1'single select deselect 
              if SelectedRow>0 then
                if entry->Selection then
                  entry->Selection=0              
                else
                  UnselectEntryList(EList)
                  entry->Selection=1
                end if      				            
                function=1
              end if          
   
            case 2 'multi select deselect 
              if SelectedRow>0 then
                entry->Selection=iif(entry->Selection=1,0,1)      				            
                function=1
              end if                  
              
          end select
          gad->ReDraw=1 
        end if
      end if
    
    case GADGET_MOUSEHOVER   'Mouse berm Control
      gad->MouseHover=1
      if gad->xtd.lbs.oldHoveredRow<>gad->xtd.lbs.HoveredRow then gad->ReDraw=1      
             
    case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
      gad->MouseHover=0
      
  end select
  
end function


sub LBS_Draw (gad as Gadget ptr)
	dim as integer GadWidth,GadHeight
	dim as integer TotalNumRows,NumRows,NumChars,RowCount
  dim as integer Offsetleft,Offsettop
  dim as integer ScrollRow,SelectedRow,HoveredRow
  dim as integer Fontheight
  dim as sGUIList ptr EList
  dim as sGUIEntry ptr Entry
  dim as FB.Image ptr buffer
  dim as string txt
  
  GadWidth =gad->GadWidth
	GadHeight=gad->GadHeight
  NumChars=gad->xtd.lbs.NumCharsPerRow'wird nicht mehr bentigt
  NumRows=gad->xtd.lbs.NumRows
	Offsetleft=gad->xtd.lbs.GapHorizontal
	Offsettop=gad->xtd.lbs.GapVertical
  ScrollRow=gad->xtd.lbs.TopRow
  SelectedRow=gad->xtd.lbs.SelectedRow
  HoveredRow=gad->xtd.lbs.HoveredRow
  RowCount=0
	EList=gad->xtd.EntryList	
	
  TotalNumRows=EList->NumNodes
  Entry=GetEntryAddr(EList,ScrollRow)
  Buffer=gad->DrawBuffer->img  
  FontHeight=GetFontHeight(0)
 
'OFF
  ClearBox Buffer,0,0,GadWidth,GadHeight
'ON
  if gad->Activation then
		FilledBoxList Buffer,0,0,GadWidth,GadHeight,Colors.GadBody,,0,0
    if TotalNumRows then
			do
				select case gad->xtd.lbs.DisplayMode'Selektionsflags interessieren hier nicht
					case 0
            if HoverFX then'generell mit Highlighting
              
              if entry->Index=HoveredRow then'wenn Zeile gehovert ist
                
                FilledBoxEntry Buffer,1,OffsetTop+RowCount*FontHeight,GadWidth-2,FontHeight,,,entry->Selection,1
                drawstring  Buffer, OffsetLeft, OffsetTop+RowCount*FontHeight ,Entry->Text,iif(entry->Selection=1,Colors.HoverFXText,Colors.HoverFXText)                       
          
              
              else'wenn Zeile nicht gehovert ist
                
                FilledBoxEntry Buffer,1,OffsetTop+RowCount*FontHeight,GadWidth-2,FontHeight,,,entry->Selection,0
                drawstring  Buffer, OffsetLeft, OffsetTop+RowCount*FontHeight ,Entry->Text,iif(entry->Selection=1,Colors.GadTextSelected,Colors.GadText)                       
              
              end if
    
            else'generell ohne Highlighting
            
              if entry->Selection then 
                FilledBoxEntry Buffer,1,OffsetTop+RowCount*FontHeight,GadWidth-2,FontHeight,,,1,0
                drawstring  Buffer, OffsetLeft, OffsetTop+RowCount*FontHeight ,Entry->Text,Colors.GadTextSelected            
              else
                drawstring  Buffer, OffsetLeft, OffsetTop+RowCount*FontHeight ,Entry->Text,Colors.GadText
              end if

            end if
          
          case 1  
            if HoverFX then'generell mit Highlighting
              
              if entry->Index=HoveredRow then'wenn Zeile gehovert ist
                
                FilledBoxEntry Buffer,1,OffsetTop+RowCount*FontHeight,GadWidth-2,FontHeight,,,entry->Selection,1
                if Entry->Selection then Symbol_CheckMark (Buffer, OffsetLeft,OffsetTop+RowCount*FontHeight,FontHeight-4,iif(entry->Selection=1,Colors.HoverFXText,Colors.HoverFXText))
                drawstring  Buffer, OffsetLeft+FontHeight, OffsetTop+RowCount*FontHeight ,Entry->Text,iif(entry->Selection=1,Colors.HoverFXText,Colors.HoverFXText)                       
          
              
              else'wenn Zeile nicht gehovert ist
                
                FilledBoxEntry Buffer,1,OffsetTop+RowCount*FontHeight,GadWidth-2,FontHeight,,,0,0
                if Entry->Selection then Symbol_CheckMark (Buffer, OffsetLeft,OffsetTop+RowCount*FontHeight,FontHeight-4,Colors.GadText)
                drawstring  Buffer, OffsetLeft+FontHeight, OffsetTop+RowCount*FontHeight ,Entry->Text,Colors.GadText                       
              
              end if
    
            else'generell ohne Highlighting
              
              FilledBoxEntry Buffer,1,OffsetTop+RowCount*FontHeight,GadWidth-2,FontHeight,,,0,0
              if entry->Selection then Symbol_CheckMark (Buffer, OffsetLeft,OffsetTop+RowCount*FontHeight,FontHeight-4,Colors.GadText)               
              drawstring  Buffer, OffsetLeft+FontHeight, OffsetTop+RowCount*FontHeight ,Entry->Text,Colors.GadText

            end if            
            
          case 2'Display Directory
              
              
              if HoverFX<>0 and (entry->Index=HoveredRow) then'wenn Zeile gehovert ist then
              
                if entry->Selection then 
                  FilledBoxEntry Buffer,1,OffsetTop+RowCount*FontHeight,GadWidth-2,FontHeight,Colors.HoverFXSelected,,0,0            
                else
                  FilledBoxEntry Buffer,1,OffsetTop+RowCount*FontHeight,GadWidth-2,FontHeight,Colors.HoverFX,,0,0
                end if                
                             
                if Entry->EntryType=ETYPE_DIR then        
                  drawstring  Buffer, OffsetLeft, OffsetTop+RowCount*FontHeight ,"<DIR> " & Entry->Text,Colors.HoverFXText
                else
                  drawstring  Buffer, OffsetLeft, OffsetTop+RowCount*FontHeight ,Entry->Text,Colors.HoverFXText
                end if                 
              
              else
             
                if entry->Selection then 
                  FilledBoxEntry Buffer,1,OffsetTop+RowCount*FontHeight,GadWidth-2,FontHeight,Colors.LBX_BackgroundSelected,,0,0
                  if Entry->EntryType=ETYPE_DIR then        
                    drawstring  Buffer, OffsetLeft, OffsetTop+RowCount*FontHeight ,"<DIR> " & Entry->Text,Colors.LBX_DirSelected
                  else
                    drawstring  Buffer, OffsetLeft, OffsetTop+RowCount*FontHeight ,Entry->Text,Colors.LBX_FileSelected
                  end if           
                
                else
                 
                  if Entry->EntryType=ETYPE_DIR then
                    drawstring  Buffer, OffsetLeft, OffsetTop+RowCount*FontHeight ,"<DIR> " & Entry->Text,Colors.LBX_DirUnselected
                  else
                    drawstring  Buffer, OffsetLeft, OffsetTop+RowCount*FontHeight ,Entry->Text,Colors.LBX_FileUnselected
                  end if
                  
                end if                          
              
              end if
                 
          case 3              
						if Entry->EntryType=ETYPE_LABEL then             
							StdFilledBox Buffer,1,OffsetTop+RowCount*FontHeight,GadWidth-2,FontHeight,Colors.WarnYellow,,0,0
							drawstring  Buffer, OffsetLeft, OffsetTop+RowCount*FontHeight ,Entry->Text,Colors.WarnRed
						else
              
              if HoverFX then'generell mit Highlighting
                
                if entry->Index=HoveredRow then'wenn Zeile gehovert ist
                  
                  FilledBoxEntry Buffer,1,OffsetTop+RowCount*FontHeight,GadWidth-2,FontHeight,,,entry->Selection,1
                  if Entry->Selection then Symbol_CheckMark (Buffer, OffsetLeft,OffsetTop+RowCount*FontHeight,FontHeight-4,iif(entry->Selection=1,Colors.HoverFXText,Colors.HoverFXText))
                  drawstring  Buffer, OffsetLeft+FontHeight, OffsetTop+RowCount*FontHeight ,Entry->Text,iif(entry->Selection=1,Colors.HoverFXText,Colors.HoverFXText)                       
            
                
                else'wenn Zeile nicht gehovert ist
                  
                  FilledBoxEntry Buffer,1,OffsetTop+RowCount*FontHeight,GadWidth-2,FontHeight,,,0,0
                  if Entry->Selection then Symbol_CheckMark (Buffer, OffsetLeft,OffsetTop+RowCount*FontHeight,FontHeight-4,Colors.GadText)
                  drawstring  Buffer, OffsetLeft+FontHeight, OffsetTop+RowCount*FontHeight ,Entry->Text,Colors.GadText                       
                
                end if
      
              else'generell ohne Highlighting
                
                FilledBoxEntry Buffer,1,OffsetTop+RowCount*FontHeight,GadWidth-2,FontHeight,,,0,0
                if entry->Selection then Symbol_CheckMark (Buffer, OffsetLeft,OffsetTop+RowCount*FontHeight,FontHeight-4,Colors.GadText)               
                drawstring  Buffer, OffsetLeft+FontHeight, OffsetTop+RowCount*FontHeight ,Entry->Text,Colors.GadText

              end if
            
            end if                      
				end select        
				
				Entry= cast(sGUIEntry ptr,Entry->next_node)
				RowCount+=1
			loop until (Entry=0) or (RowCount=NumRows)'kein Eintrag mehr oder der Zeilenzhler=Anzahl der zu zeigenden Zeilen
		end if
'SLEEP
    if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
  end if

end sub


sub VScrollLBS(gad as Gadget ptr,ScrollRow as integer)
  gad->xtd.lbs.TopRow=ScrollRow
  gad->ReDraw=1
end sub

sub LBS_Update(gad as Gadget ptr)
  if (gad->MouseHover=0) and (gad->xtd.lbs.HoveredRow<>0) then
    gad->xtd.lbs.HoveredRow=0   
    gad->ReDraw=1  
  end if
  
end sub

sub UnselectEntryList(EList as sGUIList ptr)
dim as sGUIEntry ptr Entry
  Entry=Elist->GetFirst
  if Entry then
    do
      entry->Selection=0
      entry=cast(sGUIEntry ptr,Entry->next_node)
    loop until (Entry=0)
  end if
end sub

end namespace
