namespace sGUI

declare function AddMenuButton (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer=0,GadHeight as integer=0, mbase as sGUIList ptr, entry as sGUIEntry ptr) as Gadget ptr

declare function MMG_Actions(gad as Gadget ptr,action as integer) as integer
declare sub MMG_Draw (gad as Gadget ptr)


declare sub MNG_Update(gad as Gadget ptr)
/'
type MNG_Data
  MenuEntry           as _sGUIEntry ptr
  ChildStripWindow    as _sGUIWindow ptr
end type
'/
function AddMenuButton (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer=0,GadHeight as integer=0, mbase as sGUIList ptr, entry as sGUIEntry ptr) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
	if win=0 then win=RootWindow
	gad=win->GadgetList->AppendNew (GadgetType)
	if gad then
		gad->parent=win
		gad->Selection=0
		gad->Activation=0
		gad->PosX=PosX
		gad->PosY=PosY
		gad->GadWidth=GadWidth
		gad->GadHeight=GadHeight
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight)
    
    gad->xtd.EntryList=mbase
    gad->xtd.mng->MenuEntry=entry

		gad->DoDraw     =@MMG_Draw
		gad->DoAction   =@MNG_Actions
    gad->DoUpdate   =@MNG_Update    
		
    function=gad
	end if
end function


sub MNG_Update(gad as Gadget ptr)
  dim as sGUIList ptr EList
	dim as sGUIEntry ptr entry
  dim as integer TotalNumRows	
	EList=gad->xtd.EntryList
  TotalNumRows=EList->NumNodes
	
  if gad->xtd.lbx.TimeStamp <> gad->xtd.EntryList->GetTimeStamp then
		gad->xtd.lbx.NumEntriesRef=TotalNumRows
    if (gad->xtd.lbx.selector->xtd.lbs.SelectedRow>TotalNumRows) or (gad->xtd.lbx.selector->xtd.lbs.SelectedRow<1) then gad->xtd.lbx.selector->xtd.lbs.SelectedRow=0   
		SetScrollBar(gad->xtd.lbx.scrollbar,1,TotalNumRows,1,gad->xtd.lbx.selector->xtd.lbs.NumRows)
    VScrollLBS(gad->xtd.lbx.selector,1)
    gad->xtd.lbx.TimeStamp = gad->xtd.EntryList->GetTimeStamp
    gad->xtd.lbx.selector->ReDraw=1
  end if
end sub



function AddToggleGadget (win as SGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer=0,GadHeight as integer=0,Text as string) as Gadget ptr
	function=0 
	dim as Gadget ptr gad
	gad=AddSimpleGadget (win,PosX,PosY,GadWidth,GadHeight,Text)
	if gad then
		gad->DoAction   =@TGB_Actions    
		function=gad
	end if
end function


function BTN_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
  select case action
    case GADGET_LMBHIT        'Control grad frisch gedrckt
      SetSelect (gad,1)
      if gad->xtd.btn.Fire then function=1'Ping!!!! Control meldet sich: bei mir ist was passiert!!!
      
    case GADGET_LMBHOLD       'Control wird gehalten, Maus ber dem Control
      SetSelect (gad,1)
      if gad->xtd.btn.Fire then function=1'Ping!!!! Control meldet sich: bei mir ist was passiert!!!
    
    case GADGET_LMBHOLDOFF    'Control wird gehalten, Maus neben dem Control
      SetSelect (gad,0)
      if gad->xtd.btn.Fire then function=1'Ping!!!! Control meldet sich: bei mir ist was passiert!!!
      
    case GADGET_LMBRELEASE    'Control regulr losgelassen
      SetSelect (gad,0)
      function=1           'Ping!!!! Control meldet sich: bei mir ist was passiert!!!        

    case GADGET_LMBRELEASEOFF 'Control losgelassen, dabei ist Maus neben dem Control
      SetSelect (gad,0)
    
    case GADGET_MOUSEHOVER   'Mouse berm Control
      gad->MouseHover=1
    
    case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
      gad->MouseHover=0       
  end select
end function


function TGB_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
  select case action
    case GADGET_LMBRELEASE    'Control regulr losgelassen
      SetSelect(gad,iif(GetSelect(gad),0,1))
      function=1
     
    case GADGET_MOUSEHOVER   'Mouse berm Control
      gad->MouseHover=1
    
    case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
      gad->MouseHover=0 
  end select
end function


sub BTN_Draw (gad as Gadget ptr)
	dim as integer GadWidth,GadHeight,TextPosX,TextPosY
	dim as FB.Image ptr buffer
	dim as ulong ColorA,ColorB,ColorC,ColorD
  
  GadWidth =gad->GadWidth
	GadHeight=gad->GadHeight
	TextPosX =int((GadWidth-GetTextWidth(gad->Text))/2)
	TextPosY =int((GadHeight-GetFontHeight)/2)
	Buffer   =gad->DrawBuffer->img
  
  if gad->xtd.btn.UseButtonColors then
    ColorA=gad->xtd.btn.GadBody
    ColorB=gad->xtd.btn.GadText
    ColorC=gad->xtd.btn.GadBodySelected 
    ColorD=gad->xtd.btn.GadTextSelected      
  else
    ColorA=Colors.GadBody
    ColorB=Colors.GadText
    ColorC=Colors.GadBodySelected 
    ColorD=Colors.GadTextSelected  
  end if
  
	'OFF 
	ClearBox Buffer,0,0,GadWidth,GadHeight
'ON   unselect/select
  if gad->Activation then
    StdFilledBox Buffer,0,0,GadWidth,GadHeight,ColorA,ColorC,gad->Selection,gad->MouseHover
		if gad->MouseHover then
      drawstring (Buffer, TextPosX, TextPosY, gad->Text,iif(gad->Selection,Colors.HoverFXText,Colors.HoverFXText))
    else
			drawstring (Buffer, TextPosX, TextPosY, gad->Text,iif(gad->Selection,ColorD,ColorB))
    end if
		'SLEEP
		if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
	end if
end sub

end namespace
