#include once "Gadget_Arrows.bas"
#include once "Gadget_ScrollBar_Container.bas"

namespace sGUI

declare function AddScrollBar(win as sGUIWindow ptr,PosX as integer,PosY as integer,SBLength as integer,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer,Orientation as integer) as Gadget ptr
declare function SCR_Actions(gad as Gadget ptr,action as integer) as integer

declare function GetScrollBar (gad as Gadget ptr) as integer
declare sub SetScrollBar overload(gad as Gadget ptr,ScrollValue as integer)
declare sub SetScrollBar (gad as Gadget ptr,Minimum as integer,Maximum as integer)
declare sub SetScrollBar (gad as Gadget ptr,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer=0)



/'
type SCR_Data
	ScrollValue 			as integer
	ScrollValueOld 		as integer
	knobcontainer			as _Gadget ptr
	Arrowincr					as _Gadget ptr
	Arrowdecr					as _Gadget ptr
end type
'/
function AddScrollBar(win as sGUIWindow ptr,PosX as integer,PosY as integer,SBLength as integer,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer,Orientation as integer) as Gadget ptr
  function=0  
  dim as Gadget ptr gad
  if win=0 then win=RootWindow
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->Selection=0
    gad->Activation=0
    gad->PosX=PosX
    gad->PosY=PosY
    gad->GadWidth=SBLength
    gad->GadHeight=MainWidth
    if Orientation then swap gad->GadWidth,gad->GadHeight'Breite und Hhe tauschen wenn vertikal
    gad->xtd.scr.ScrollValue=ScrollValue
  
    gad->GadgetWindow=AddWindow(gad,0,0,gad->GadWidth,gad->GadHeight,,)  
    if gad->GadgetWindow then
      gad->GadgetWindow->Activation=1
      gad->GadgetWindow->Selection=1
      
      if Orientation then       'wenn vertikal
        if SBLength < (3*MainWidth + 2) then
          gad->xtd.scr.knobcontainer	=AddScrollBarContainer(gad->GadgetWindow,0,0,gad->GadHeight,Minimum,Maximum,ScrollValue,PageSize,1)
        else
          gad->xtd.scr.knobcontainer	=AddScrollBarContainer(gad->GadgetWindow,0,0,gad->GadHeight-(2*MainWidth+2),Minimum,Maximum,ScrollValue,PageSize,1)
          gad->xtd.scr.Arrowdecr			=AddArrow(gad->GadgetWindow, 0, gad->GadHeight-(2*MainWidth+1), 2)
          gad->xtd.scr.Arrowincr			=AddArrow(gad->GadgetWindow, 0, gad->GadHeight-MainWidth, 3)
        end if
      else                      'wenn horizontal
        if SBLength < 51 then
          gad->xtd.scr.knobcontainer	=AddScrollBarContainer(gad->GadgetWindow,0,0,gad->GadWidth,Minimum,Maximum,ScrollValue,PageSize,0)
        else
          gad->xtd.scr.knobcontainer	=AddScrollBarContainer(gad->GadgetWindow,0,0,gad->GadWidth-(2*MainWidth+2),Minimum,Maximum,ScrollValue,PageSize,0)
          gad->xtd.scr.Arrowdecr			=AddArrow(gad->GadgetWindow, gad->GadWidth-(2*MainWidth+1), 0, 0)
          gad->xtd.scr.Arrowincr			=AddArrow(gad->GadgetWindow, gad->GadWidth-MainWidth, 0, 1)
        end if
      end if
    end if
    
    gad->DoAction   =@SCR_Actions
    function=gad
  end if
end function



function SCR_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
	dim as integer WheelSensorX,WheelSensorY  
  gad->xtd.scr.ScrollValueOld=gad->xtd.scr.ScrollValue'alten Scrollwert merken  
  
  select case action
    case GADGET_WHEELMOVE      
      GetGlobalPosition(gad,WheelSensorX,WheelSensorY)
      if (MOUSEX>=WheelSensorX) and (MOUSEX<WheelSensorX + gad->GadWidth) and _
         (MOUSEY>=WheelSensorY) and (MOUSEY<WheelSensorY + gad->GadHeight) then
        gad->xtd.scr.ScrollValue +=WHEEL * gad->xtd.scr.knobcontainer->xtd.sbc.PageSize'page step
        'gad->xtd.scr.ScrollValue +=WHEEL'single step
        SetSBCVal(gad->xtd.scr.knobcontainer,gad->xtd.scr.ScrollValue)
        gad->xtd.scr.ScrollValue=GetSBCVal(gad->xtd.scr.knobcontainer)
      end if
      

    case GADGET_LOOPTHROUGH
      if GADGETMESSAGE then' wenn im GadgetWindow irgendeines der Controls ein Action meldet, dann...          
        gad->xtd.scr.ScrollValue=GetSBCVal(gad->xtd.scr.knobcontainer)'egal welches der 3 Controls angeklickt wurde, Scrollbar auslesen
        select case GADGETMESSAGE
          case gad->xtd.scr.knobcontainer
            'seltsam, beim Bewegen des Scrollbars mu garnichts passieren :D
          case gad->xtd.scr.Arrowdecr
            gad->xtd.scr.ScrollValue -=1
            SetSBCVal(gad->xtd.scr.knobcontainer,gad->xtd.scr.ScrollValue)
            gad->xtd.scr.ScrollValue=GetSBCVal(gad->xtd.scr.knobcontainer)
          case gad->xtd.scr.Arrowincr
            gad->xtd.scr.ScrollValue +=1
            SetSBCVal(gad->xtd.scr.knobcontainer,gad->xtd.scr.ScrollValue)
            gad->xtd.scr.ScrollValue=GetSBCVal(gad->xtd.scr.knobcontainer)
         end select
      end if 
     
    case GADGET_MOUSEHOVER
      gad->MouseHover=1
   
    case GADGET_MOUSENEXT
      gad->MouseHover=0
  end select

  if gad->xtd.scr.ScrollValueOld<>gad->xtd.scr.ScrollValue then 
    gad->xtd.scr.knobcontainer->ReDraw=1
    function=1'wenn Unterschied zw. altem Scrollwert und aktuellem, dann Ping!        
  end if  
end function


function GetScrollBar (gad as Gadget ptr) as integer
  function=GetSBCVal(gad->xtd.scr.knobcontainer)
end function


sub SetScrollBar (gad as Gadget ptr,ScrollValue as integer)
  SetSBCVal (gad->xtd.scr.knobcontainer,ScrollValue)
  gad->xtd.scr.ScrollValue=GetScrollBar (gad)
end sub


sub SetScrollBar (gad as Gadget ptr,Minimum as integer,Maximum as integer)
  SetSBCLimits(gad->xtd.scr.knobcontainer,Minimum,Maximum)
end sub


sub SetScrollBar (gad as Gadget ptr,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer=0)
  SetSBCLimits(gad->xtd.scr.knobcontainer,Minimum,Maximum,PageSize)
  SetSBCVal (gad->xtd.scr.knobcontainer,ScrollValue)
  gad->xtd.scr.ScrollValue=GetScrollBar (gad)
end sub

end namespace
