#include once "Gadget_Edit_Display.bas"
#include once "Gadget_ScrollBar.bas"

namespace sGUI

declare function AddTextField(win as sGUIWindow ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,Mode as integer=0) as Gadget ptr
declare function EDB_Actions(gad as Gadget ptr,action as integer) as integer
declare sub EDB_Draw (gad as Gadget ptr)
declare sub EDB_Update (gad as Gadget ptr)

/'
type EDB_Data
	Mode					      as integer
	CharsPerWidth       as integer'PageSize horiz. Scrollbar
	RowsPerHeight				as integer'PageSize vert. Scrollbar   
  NumRows             as integer'Abgleich, bei Vernderungen im Text mu Update erfolgen
  LongestRow          as integer'"
  CursorRow           as integer'"
  CursorPos           as integer'"
  TimeStamp           as double
	edit         			  as _Gadget ptr
	vscroll 					  as _Gadget ptr
	hscroll 					  as _Gadget ptr  
end type
'/
function AddTextField(win as sGUIWindow ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,Mode as integer=0) as Gadget ptr
  function=0
  dim as Gadget ptr gad
  if win=0 then win=RootWindow
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->Selection=0
    gad->Activation=0
    gad->PosX=PosX
    gad->PosY=PosY
    gad->GadWidth=BoxWidth
    gad->GadHeight=BoxHeight    
    gad->xtd.edb.Mode=Mode
    
    'gad->xtd.edb.CharsPerWidth=int((BoxWidth  - 2*LeastGap - 16 - 1)/GetFixedWidth)
    'gad->xtd.edb.RowsPerHeight=int((BoxHeight - 2*LeastGap - 16 - 1)/GetFontHeight(1))
          
    gad->GadgetWindow=AddWindow(gad,0,0,gad->GadWidth,gad->GadHeight,,) 
    if gad->GadgetWindow then
      gad->GadgetWindow->Activation=1
      gad->GadgetWindow->Selection=1    
      gad->xtd.edb.edit   		=AddEditDisplay (gad->GadgetWindow,0,0,gad->GadWidth-(MainWidth+1),gad->GadHeight-(MainWidth+1),Mode)'MainWidth+1 bedeutet 1 Pixel Lcke zu den Scrollbar
      gad->xtd.edb.vscroll		=AddScrollBar(gad->GadgetWindow,gad->GadWidth-MainWidth,0,gad->GadHeight-(MainWidth+1),1,1,1,1,1)'MainWidth+1 bedeutet 1 Pixel krzere Scrollbar
      gad->xtd.edb.hscroll		=AddScrollBar(gad->GadgetWindow,0,gad->GadHeight-MainWidth,gad->GadWidth-(MainWidth+1),1,1,1,1,0)			
       
      gad->xtd.edb.CharsPerWidth=gad->xtd.edb.edit->xtd.edd.CharsPerWidth
      gad->xtd.edb.RowsPerHeight=gad->xtd.edb.edit->xtd.edd.RowsPerHeight
    end if
		gad->xtd.TContainer	=gad->xtd.edb.edit->xtd.TContainer
    
    gad->DoAction   =@EDB_Actions
    gad->DoUpdate   =@EDB_Update
		function=gad
  end if
end function


function EDB_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
  dim as Gadget ptr edit,vscroll,hscroll
  dim as sGUIText ptr TContainer
  dim as integer WheelSensorX,WheelSensorY
  edit=gad->xtd.edb.edit
  vscroll=gad->xtd.edb.vscroll
  hscroll=gad->xtd.edb.hscroll
  TContainer=gad->xtd.TContainer
  
  dim as integer enable,scrollbarmodify
  scrollbarmodify=0
  
  select case action
    case GADGET_LMBHIT
      SetSelect(edit,1)
      function=-1

    case GADGET_KEYBOARD   'Keyboardauswertung
      SetSelect(edit,1)
      
      'Pfeiltasten/Cursorbewegung in beiden Modi erlaubt
      if  EXTENDED then
        'Cursorbewegung mit Pfeiltasten
        if ASCCODE=75 then TContainer->CursorLeft
        if ASCCODE=77 then TContainer->CursorRight
        if ASCCODE=72 then TContainer->CursorUp
        if ASCCODE=80 then TContainer->CursorDown
        'added by MilkFreeze, modified by Muttonhead :D
        if ASCCODE=71 then TContainer->CursorKeyPos1
        if ASCCODE=79 then TContainer->CursorKeyEnd
        scrollbarmodify=1      
      end if
      
      'Editieren nur in Mode 0 erlaubt
      if gad->xtd.edb.Mode=0 then
        if  EXTENDED then
          'DEL Windows
          #ifdef __fb_win32__
            if ASCCODE=83 then
              TContainer->KeyDelete
              scrollbarmodify=2
            end if
          #endif
        else
          'BACKSPACE
          if ASCCODE=8 then
            TContainer->KeyBackspace
            scrollbarmodify=2
          end if
          'DEL Linux
          #ifdef __fb_linux__
            if ASCCODE=127 then
              TContainer->KeyDelete
              scrollbarmodify=2    
            end if
          #endif
          'Return
          if ASCCODE=13 then
            TContainer->KeyReturn
            scrollbarmodify=2
          end if
          
          'Zeicheneingabe
          enable=0

          'Linux chr(127)->Delete ausschlieen
          #ifdef __fb_linux__
            if ASCCODE>=32 and ASCCODE<>127 then enable=1
          #endif

          'Windows
          #ifdef __fb_win32__
            if ASCCODE>=32 then enable=1
          #endif

          if enable then
            TContainer->KeyAddChar(KEY)
            scrollbarmodify=2
          end if
        end if                
      end if
     
    case GADGET_KEYBOARDOFF'Abbruch Keyboardauswertung
      SetSelect(edit,0)
      gad->ReDraw=1
      function=-1
      
    case GADGET_WHEELMOVE
      GetGlobalPosition(gad->xtd.edb.edit,WheelSensorX,WheelSensorY)
      if (MOUSEX>=WheelSensorX) and (MOUSEX<WheelSensorX + gad->xtd.edb.edit->GadWidth) and _
         (MOUSEY>=WheelSensorY) and (MOUSEY<WheelSensorY + gad->xtd.edb.edit->GadHeight) then
          SetScrollBar(vscroll,GetScrollBar( vscroll ) + WHEEL*3 )
          VScrollEditDisplay(edit,GetScrollBar(vscroll))
          gad->ReDraw=1
      end if      
    
    case GADGET_LOOPTHROUGH
      if GADGETMESSAGE then
        select case GADGETMESSAGE
          case edit
            scrollbarmodify=2
          case vscroll
            VScrollEditDisplay(edit,GetScrollBar(vscroll))
          case hscroll
            HScrollEditDisplay(edit,GetScrollBar(hscroll))
        end select
      end if
      
  end select
  
  select case scrollbarmodify
    case 1
      SetScrollBar(vscroll,TraceCursorRow(edit))
      SetScrollBar(hscroll,TraceCursorPosition(edit))        
    case 2
      SetScrollBar(vscroll,1,TContainer->GetNumRows+1,TraceCursorRow(edit))
      SetScrollBar(hscroll,TraceCursorPosition(edit))        
  end select
end function


sub EDB_Update(gad as Gadget ptr)
  dim as Gadget ptr edit,vscroll,hscroll
  dim as sGUIText ptr TContainer
  edit=gad->xtd.edb.edit
  vscroll=gad->xtd.edb.vscroll
  hscroll=gad->xtd.edb.hscroll
  TContainer=gad->xtd.TContainer

  if gad->xtd.edb.TimeStamp <> gad->xtd.TContainer->GetTimeStamp then
    gad->xtd.edb.NumRows = gad->xtd.TContainer->GetNumRows
    gad->xtd.edb.LongestRow = gad->xtd.TContainer->GetLongestRow
    gad->xtd.edb.CursorRow = gad->xtd.TContainer->GetCursorRow
    gad->xtd.edb.CursorPos = gad->xtd.TContainer->GetCursorPosition
    
    SetScrollBar(vscroll,1,gad->xtd.edb.NumRows,TraceCursorRow(edit),gad->xtd.edb.RowsPerHeight)
    SetScrollBar(hscroll,1,gad->xtd.edb.LongestRow+1,TraceCursorPosition(edit),gad->xtd.edb.CharsPerWidth)      
    
    VScrollEditDisplay(edit,GetScrollBar(vscroll))
    HScrollEditDisplay(edit,GetScrollBar(hscroll))  
    gad->xtd.edb.TimeStamp = gad->xtd.TContainer->GetTimeStamp
    gad->xtd.edb.edit->ReDraw=1   
  end if
end sub

end namespace
