type ColorStorage
  '0  AlphaValue 
  '1  Clean
  '2  Black  
  '3  White
  '4  WarnRed
  '5  WarnYellow
  '6  WarnGreen

  '7  Pen
  '8  BackGround	      
  
  '9  WinFrame
  '10 WinText  
  '11 WinFrameUnselected    	
  '12 WinTextUnselected	 
  
  '13 GadBody
  '14 GadText  
  '15 GadBodySelected
  '16 GadTextSelected  

	'17 HoverFX
  '18 HoverFXSelected
  '19 HoverFXText	
  
  '20 GadSleepPattern
  
  '21 SCR_Container  
  
  '22 EBX_Pen
  '23 EBX_BackGround
  '24 EBX_BackGround
  
  '25 LBX_DirUnselected
  '26 LBX_DirSelected
  '27 LBX_FileUnselected
  '28 LBX_FileSelected
  '29 LBX_BackGroundSelected  

  Storage(30) as ulong
  
  declare property AlphaValue (Value as ubyte)   
  declare property Cleaning as ulong
  declare property Cleaning (RGBValue as ulong)
  declare property Black as ulong
  declare property White as ulong
  declare property WarnRed as ulong
  declare property WarnYellow as ulong  
  declare property WarnGreen as ulong
  
  declare property Pen as ulong
  declare property Pen (RGBValue as ulong)  
  declare property BackGround as ulong
  declare property BackGround (RGBValue as ulong)
  
  declare property WinFrame as ulong
  declare property WinFrame (RGBValue as ulong)
  declare property WinText as ulong
  declare property WinText (RGBValue as ulong)
  
  declare property WinFrameUnselected as ulong
  declare property WinFrameUnselected (RGBValue as ulong)
  declare property WinTextUnselected as ulong
  declare property WinTextUnselected (RGBValue as ulong)

  declare property GadBody as ulong
  declare property GadBody (RGBValue as ulong)
  declare property GadText as ulong
  declare property GadText (RGBValue as ulong)  
  declare property GadBodySelected as ulong
  declare property GadBodySelected (RGBValue as ulong)
  declare property GadTextSelected as ulong
  declare property GadTextSelected (RGBValue as ulong)
  
  declare property HoverFX as ulong
  declare property HoverFX (RGBValue as ulong)
  declare property HoverFXSelected as ulong
  declare property HoverFXSelected (RGBValue as ulong)   
  declare property HoverFXText as ulong
  declare property HoverFXText (RGBValue as ulong)
  
  declare property GadSleepPattern as ulong
  declare property GadSleepPattern (RGBValue as ulong)
   
  declare property SCR_Container as ulong
  declare property SCR_Container (RGBValue as ulong) 
  
  declare property EBX_Pen as ulong
  declare property EBX_Pen (RGBValue as ulong)    
  declare property EBX_BackGround as ulong
  declare property EBX_BackGround (RGBValue as ulong)  
  declare property EBX_Cursor as ulong
  declare property EBX_Cursor (RGBValue as ulong)
  declare property LBX_DirUnselected as ulong
  declare property LBX_DirUnselected (RGBValue as ulong)
  declare property LBX_DirSelected as ulong
  declare property LBX_DirSelected (RGBValue as ulong)   
  declare property LBX_FileUnselected as ulong
  declare property LBX_FileUnselected (RGBValue as ulong)  
  declare property LBX_FileSelected as ulong
  declare property LBX_FileSelected (RGBValue as ulong)    
  declare property LBX_BackgroundSelected as ulong
  declare property LBX_BackgroundSelected (RGBValue as ulong)
 
  
  declare constructor
  declare sub AlphaRules
end type

constructor ColorStorage
  AlphaValue=255
  Storage(0)=Storage(0) shl 24
  Storage(1)=&HFF00FF
  Storage(2)=&HFFFFFF
  Storage(3)=&H0
  Storage(4)=&HDD0000
  Storage(5)=&HFFDD00 
  Storage(6)=&H00DD00
  AlphaRules
end constructor

sub ColorStorage.AlphaRules
  'Regelwerk, auf welchen RGBWerten der Alphawert angewendet wird
  'hier sind es noch alle, mal sehen, ob sich es ndert
  for i as integer=1 to ubound(Storage)
    Storage(i) = (Storage(i) and &HFFFFFF) or Storage(0)
  next i  
end sub

property ColorStorage.AlphaValue (ByteValue as ubyte)'das UBYTE limitiert den Wert: 0 - 255
  Storage(0)=ByteValue
  Storage(0)=Storage(0) shl 24  
  AlphaRules
end property

'in den anderen (Farb-)Properties kann und soll separat entschieden werden, wie
'mit dem Alphawert gearbeitet wird. Im Moment machen alle Properties das gleiche:
'**********************************************
property ColorStorage.Cleaning as ulong
  Cleaning=Storage(1)
end property

property ColorStorage.Cleaning (RGBValue as ulong)
  Storage(1) = (RGBValue and &HFFFFFF) or Storage(0)
end property

'**********************************************
property ColorStorage.White as ulong
  White=Storage(2)
end property

'**********************************************
property ColorStorage.Black as ulong
  Black=Storage(3)
end property

'**********************************************
property ColorStorage.WarnRed as ulong
  WarnRed=Storage(4)
end property

'**********************************************
property ColorStorage.WarnYellow as ulong
  WarnYellow=Storage(5)
end property

'**********************************************
property ColorStorage.WarnGreen as ulong
  WarnGreen=Storage(6)
end property

'**********************************************
'**********************************************
property ColorStorage.Pen as ulong
  Pen=Storage(7)
end property

property ColorStorage.Pen (RGBValue as ulong)
  Storage(7) = (RGBValue and &HFFFFFF) or Storage(0)
  'color Storage(7)
end property

'**********************************************
property ColorStorage.BackGround as ulong
  BackGround=Storage(8)
end property

property ColorStorage.BackGround (RGBValue as ulong)
  Storage(8) = (RGBValue and &HFFFFFF) or Storage(0)
  'color ,Storage(8)
end property

'**********************************************
'**********************************************
property ColorStorage.WinFrame as ulong
  WinFrame=Storage(9)
end property

property ColorStorage.WinFrame (RGBValue as ulong)
  Storage(9) = (RGBValue and &HFFFFFF) or Storage(0)
end property

'**********************************************
property ColorStorage.WinText as ulong
  WinText=Storage(10)
end property

property ColorStorage.WinText (RGBValue as ulong)
  Storage(10) = (RGBValue and &HFFFFFF) or Storage(0)
end property

'**********************************************

property ColorStorage.WinFrameUnselected as ulong
  WinFrameUnselected=Storage(11)
end property

property ColorStorage.WinFrameUnselected (RGBValue as ulong)
  Storage(11) = (RGBValue and &HFFFFFF) or Storage(0)
end property

'**********************************************
property ColorStorage.WinTextUnselected as ulong
  WinTextUnselected=Storage(12)
end property

property ColorStorage.WinTextUnselected (RGBValue as ulong)
  Storage(12) = (RGBValue and &HFFFFFF) or Storage(0)
end property

'**********************************************
'**********************************************
property ColorStorage.GadBody as ulong
  GadBody=Storage(13)
end property

property ColorStorage.GadBody (RGBValue as ulong)
  Storage(13) = (RGBValue and &HFFFFFF) or Storage(0)
end property

'**********************************************
property ColorStorage.GadText as ulong
  GadText=Storage(14)
end property

property ColorStorage.GadText (RGBValue as ulong)
  Storage(14) = (RGBValue and &HFFFFFF) or Storage(0)
end property

'**********************************************
property ColorStorage.GadBodySelected as ulong
  GadBodySelected=Storage(15)
end property

property ColorStorage.GadBodySelected (RGBValue as ulong)
  Storage(15) = (RGBValue and &HFFFFFF) or Storage(0)
end property

'**********************************************
property ColorStorage.GadTextSelected as ulong
  GadTextSelected=Storage(16)
end property

property ColorStorage.GadTextSelected (RGBValue as ulong)
  Storage(16) = (RGBValue and &HFFFFFF) or Storage(0)
end property

'**********************************************
'**********************************************
property ColorStorage.HoverFX as ulong
  HoverFX=Storage(17)
end property

property ColorStorage.HoverFX (RGBValue as ulong)
  Storage(17) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************

property ColorStorage.HoverFXSelected as ulong
  HoverFXSelected=Storage(18)
end property

property ColorStorage.HoverFXSelected (RGBValue as ulong)
  Storage(18) = (RGBValue and &HFFFFFF) or Storage(0)
end property


'**********************************************
property ColorStorage.HoverFXText as ulong
  HoverFXText=Storage(19)
end property

property ColorStorage.HoverFXText (RGBValue as ulong)
  Storage(19) = (RGBValue and &HFFFFFF) or Storage(0)
end property

'**********************************************
'**********************************************
property ColorStorage.GadSleepPattern as ulong
  GadSleepPattern=Storage(20)
end property

property ColorStorage.GadSleepPattern (RGBValue as ulong)
  Storage(20) = (RGBValue and &HFFFFFF) or Storage(0)
end property

'**********************************************
'**********************************************
property ColorStorage.SCR_Container as ulong
  SCR_Container=Storage(21)
end property

property ColorStorage.SCR_Container (RGBValue as ulong)
  Storage(21) = (RGBValue and &HFFFFFF) or Storage(0)
end property

'**********************************************
'**********************************************
property ColorStorage.EBX_Pen as ulong
  EBX_Pen=Storage(22)
end property

property ColorStorage.EBX_Pen (RGBValue as ulong)
  Storage(22) = (RGBValue and &HFFFFFF) or Storage(0)
end property

property ColorStorage.EBX_BackGround as ulong
  EBX_BackGround=Storage(23)
end property

property ColorStorage.EBX_BackGround (RGBValue as ulong)
  Storage(23) = (RGBValue and &HFFFFFF) or Storage(0)
end property

property ColorStorage.EBX_Cursor as ulong
  EBX_Cursor=Storage(24)
end property

property ColorStorage.EBX_Cursor (RGBValue as ulong)
  Storage(24) = (RGBValue and &HFFFFFF) or Storage(0)
end property

'**********************************************
'********************************************** 
property ColorStorage.LBX_DirUnselected as ulong
  LBX_DirUnselected=Storage(25)
end property

property ColorStorage.LBX_DirUnselected (RGBValue as ulong)
  Storage(25) = (RGBValue and &HFFFFFF) or Storage(0)
end property

property ColorStorage.LBX_DirSelected as ulong
  LBX_DirSelected=Storage(26)
end property

property ColorStorage.LBX_DirSelected (RGBValue as ulong)
  Storage(26) = (RGBValue and &HFFFFFF) or Storage(0)
end property

property ColorStorage.LBX_FileUnselected as ulong
  LBX_FileUnselected=Storage(27)
end property

property ColorStorage.LBX_FileUnselected (RGBValue as ulong)
  Storage(27) = (RGBValue and &HFFFFFF) or Storage(0)
end property

property ColorStorage.LBX_FileSelected as ulong
  LBX_FileSelected=Storage(28)
end property

property ColorStorage.LBX_FileSelected (RGBValue as ulong)
  Storage(28) = (RGBValue and &HFFFFFF) or Storage(0)
end property

property ColorStorage.LBX_BackgroundSelected as ulong
  LBX_BackgroundSelected=Storage(29)
end property

property ColorStorage.LBX_BackgroundSelected (RGBValue as ulong)
  Storage(29) = (RGBValue and &HFFFFFF) or Storage(0)
end property

