'Color Stuff
declare function ColorSelection (BodyColor as ulong, BodySelectColor as ulong, selected as integer ,hover as integer,hovermode as integer=0) as ulong
declare sub CalcPale(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
declare sub CalcDark(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
declare sub CalcShiny(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
'Fill Basics
declare sub ClearBox (img as FB.Image ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,col as ulong=Colors.Cleaning)
declare sub Raster(img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,col as ulong=Colors.GadSleepPattern)
declare sub GradientFXBox(img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer, _
                    ColorTopLeft as ulong,ColorTopRight as ulong,ColorBottomLeft as ulong,ColorBottomRight as ulong)
'Fills
declare sub StdFill (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub AltFillA (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)

'Frames
declare sub GetFrameColor( b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0, byref ci as ColorInfo)
declare sub StdFrame (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0, switch as integer=-1)
declare sub WinFrame (img as FB.Image ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,selected as integer=0)
'Boxes
declare sub StdFilledBox (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub FilledBoxKnob (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub FilledBoxContainer (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub FilledBoxDrop (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0,mode as integer=0)
declare sub FilledBoxList (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub FilledBoxEntry (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub FilledBoxRadio (img as FB.Image ptr, PosX as integer,PosY as integer,BoxSize as integer,Radius as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub FilledBoxCheckMark (img as FB.Image ptr, PosX as integer,PosY as integer,BoxSize as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
'Symbols
declare sub Symbol_Arrow (img as FB.Image ptr, PosX as integer,PosY as integer,size as integer,direction as integer,col as ulong,thickness as integer=2)

declare sub Symbol_CheckMark (img as FB.Image ptr, PosX as integer,PosY as integer,size as integer,col as ulong=Colors.Black)
declare sub Symbol_X (img as FB.Image ptr, PosX as integer,PosY as integer, col as ulong=Colors.Black)
declare sub Symbol_Cyclic (img as FB.Image ptr, PosX as integer,PosY as integer, col as ulong=Colors.Black)
declare sub DrawRBMask(img as FB.Image ptr, DrawSize as integer, Radius as integer)


'******************************************************************************
'******************************************************************************
'******************************************************************************
'Color Stuff


function ColorSelection (BodyColor as ulong, BodySelectColor as ulong, selected as integer ,hover as integer,hovermode as integer=0) as ulong
  dim as ulong col
  if hover then
    
    select case hovermode
      case 0
        col=iif(selected=1,Colors.HoverFXSelected,Colors.HoverFX)
      case 1
        col=Colors.HoverFX
    end select
  
  else
    
    col=iif(selected=1,BodySelectColor,BodyColor) 
  
  end if
  
  function=col
end function


sub CalcPale(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
  dim as single s,v

  s=ciBase.Saturation - ciBase.Saturation*(Intensity/101)
  v=ciBase.Value + (100-ciBase.Value)*(Intensity/101)
  SetHSV (ciDest, ciBase.Hue,s,v)
end sub



sub CalcDark(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
  dim as single s,v

  if ciBase.Saturation>0 then s=ciBase.Saturation + (100-ciBase.Saturation)*(Intensity/101) else s=0'verhindert Rotstich
  v=ciBase.Value - ciBase.Value*Intensity/101
  SetHSV (ciDest, ciBase.Hue,s,v)
end sub



sub CalcShiny(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
  dim as single s,v
  
  if ciBase.Saturation>0 then s=ciBase.Saturation + (100-ciBase.Saturation)*(Intensity/101) else s=0'verhindert Rotstich 
  v=ciBase.Value + (100-ciBase.Value)*(Intensity/101)
  SetHSV (ciDest, ciBase.Hue,s,v)
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'Fill Basics


sub ClearBox (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,col as ulong=Colors.Cleaning)
  line img, (PosX,PosY)-(PosX+BoxWidth-1,PosY+BoxHeight-1),col,BF
end sub


sub Raster(img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,col as ulong=Colors.GadSleepPattern)
  for k as integer=0 to BoxHeight-1 step 2
    for i as integer=0 to BoxWidth-1 step 4
      pset img,(Posx+i, PosX+k),col
      pset img,(Posx+i+1, PosX+k),col
      
      if ((k+1) <= (BoxHeight-1)) then
        if ((i+3) <= (BoxWidth-1)) then
          pset img,(Posx+i+2, PosX+k+1),col
          pset img,(Posx+i+3, PosX+k+1),col      
        end if
      end if
    next i
  next k
end sub


sub GradientFXFill(img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer, _
                    ColorTopLeft as ulong,ColorTopRight as ulong,ColorBottomLeft as ulong,ColorBottomRight as ulong)
  'Image/Screen Infos Pointer
  #if __FB_VERSION__ >= "1.08.0"
    #if defined (__fb_64bit__) 
      dim as ulong bpp,ptch                
    #else
      dim as integer bpp,ptch      
    #endif    
  #else
    dim as integer bpp,ptch
  #endif  
  dim as any ptr pdata
  dim as ulong ptr pxladdr    
  'Mathe und Farben
  dim as ulong cs,ce
  dim as integer bw,bh
  
  if img then
    imageinfo (img, , , bpp, ptch, pdata)  
  else
    screeninfo ( , , , bpp, ptch) 
    pdata=screenptr
  end if
  'Berechnungen aus Schleife herausholen
  bw=BoxWidth-1
  bh=BoxHeight-1
  
  for y as integer=0 to bh
    cs=MixColor (ColorTopLeft, ColorBottomLeft, y/bh)
    ce=MixColor (ColorTopRight, ColorBottomRight, y/bh)   
    for x as integer=0 to bw
      'direkt in Screen/Image schreiben = bei mir etwa 45% schneller als die PSET Variante
      'erfordert eventuell screenlock/unlock
      pxladdr =pdata + (PosY+y) * ptch + (PosX+x) * bpp
      *pxladdr=MixColor (cs, ce, x/bw) 
      
      'ber PSET = langsamer
      'pset (PosX+x,PosY+y), MixColor (cs, ce, x/bw)
    next x
  next y
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'Fills
sub StdFill (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  dim as ColorInfo fill,dark,shade,colorfx,lightfx
  dim as integer d1,d2,d3,d4
  SetRGB(fill,  ColorSelection(b, s, selected,hover) )

  if GradientFX>0 then
    CalcDark(fill,GradientFX,dark)
    CalcDark(fill,GradientFX*.66,shade)
    CalcPale(fill,GradientFX*.50,lightfx)   
    CalcShiny(fill,GradientFX*.66,colorfx)

    if BoxWidth>=BoxHeight then
      d1=BoxHeight*.30
      d2=BoxHeight*.33
      d3=d2-d1
      d4=BoxHeight-d2    
      GradientFXFill img,PosX,PosY,BoxWidth,d1,lightfx.RGBValue,shade.RGBValue,dark.RGBValue,dark.RGBValue    
      ClearBox img,PosX,PosY+d1,BoxWidth,d3,dark.RGBValue 
      GradientFXFill img,PosX,PosY+d2,BoxWidth,d4,dark.RGBValue,dark.RGBValue,shade.RGBValue,colorfx.RGBValue    
    else
      d1=BoxWidth*.30
      d2=Boxwidth*.33
      d3=d2-d1
      d4=BoxWidth-d2    
      GradientFXFill img,PosX,PosY,d1,BoxHeight,lightfx.RGBValue,dark.RGBValue,shade.RGBValue,dark.RGBValue   
      ClearBox img,PosX+d1,PosY,d3,BoxHeight,dark.RGBValue
      GradientFXFill img,PosX+d2,PosY,d4,BoxHeight,dark.RGBValue,shade.RGBValue,dark.RGBValue,colorfx.RGBValue  
    end if
  
  else   
   
    ClearBox img,PosX,PosY,BoxWidth,BoxHeight,fill.RGBValue 
  end if
end sub


sub _StdFill (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  dim as ColorInfo fill,dark,shade,colorfx,lightfx
  dim as integer s1,s2
  SetRGB(fill,  ColorSelection(b, s, selected,hover) )

  if GradientFX>0 then
    CalcDark(fill,GradientFX,dark)
    CalcDark(fill,GradientFX*.66,shade)
    CalcPale(fill,GradientFX*.75,lightfx)   
    CalcShiny(fill,GradientFX*.86,colorfx)
    
    if BoxWidth>=BoxHeight then
      s1=BoxHeight*.5
      s2=BoxHeight-s1   
      GradientFXFill img,PosX,PosY,BoxWidth,s1,lightfx.RGBValue,dark.RGBValue,dark.RGBValue,dark.RGBValue
      GradientFXFill img,PosX,PosY+s1,BoxWidth,s2,dark.RGBValue,dark.RGBValue,shade.RGBValue,colorfx.RGBValue      
    else
      s1=BoxWidth*.5
      s2=BoxWidth-s1     
      GradientFXFill img,PosX,PosY,s1,BoxHeight,lightfx.RGBValue,dark.RGBValue,dark.RGBValue,dark.RGBValue
      GradientFXFill img,PosX+s1,PosY,s2,BoxHeight,dark.RGBValue,shade.RGBValue,dark.RGBValue,colorfx.RGBValue      
    end if
  
  else   
   
    ClearBox img,PosX,PosY,BoxWidth,BoxHeight,fill.RGBValue 
  end if
end sub


sub AltFillA (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  dim as ColorInfo fill,dark,shade,colorfx,lightfx

  SetRGB(fill,  ColorSelection(b, s, selected,hover) )

  if GradientFX>0 then
    CalcDark(fill,GradientFX*.33,dark)
    CalcDark(fill,GradientFX*.25,shade)       
    CalcPale(fill,GradientFX*.33,lightfx)

    
    
    if BoxWidth>=BoxHeight then   
      GradientFXFill img,PosX,PosY,BoxWidth,BoxHeight,dark.RGBValue,dark.RGBValue,shade.RGBValue,lightfx.RGBValue   
    else    
      GradientFXFill img,PosX,PosY,BoxWidth,BoxHeight,dark.RGBValue,shade.RGBValue,dark.RGBValue,lightfx.RGBValue     
    end if
  
  else   
   
    ClearBox img,PosX,PosY,BoxWidth,BoxHeight,fill.RGBValue 
  end if
end sub



'******************************************************************************
'******************************************************************************
'******************************************************************************
'Frames


sub GetFrameColor( b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0, byref ci as ColorInfo)
  dim as ColorInfo c
  SetRGB(c, ColorSelection(b, s, selected,hover)) 
  
  if FrameContrastFX<0 then
    CalcDark(c,FrameContrastFX*-1,ci)'->Abdunkeln, letztlich Schwarz
  else
    CalcPale(c,FrameContrastFX,ci)'->Aufhellung, letztlich Weiss      
  end if
end sub


sub StdFrame (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0, switch as integer=-1)
  dim as ColorInfo frame,pale,dark
  GetFrameColor(b,s,selected,hover,frame)
  if switch>-1 then selected=switch
  
  CalcPale(frame, BevelFX, pale)
  CalcDark(frame, BevelFX, dark)

  if selected then     
    line img, (PosX,PosY)	-(PosX+BoxWidth-1,PosY),dark.RGBValue'oben
    line img, (PosX,PosY+BoxHeight-1)-(PosX+BoxWidth-1,PosY+BoxHeight-1),pale.RGBValue'unten      
    line img, (PosX,PosY+1)-(PosX,PosY+BoxHeight-2),dark.RGBValue'links
    line img, (PosX+BoxWidth-1,PosY+1)-(PosX+BoxWidth-1,PosY+BoxHeight-2),pale.RGBValue'rechts    
  else
    line img, (PosX,PosY)	-(PosX+BoxWidth-1,PosY),pale.RGBValue'oben
    line img, (PosX,PosY+BoxHeight-1)-(PosX+BoxWidth-1,PosY+BoxHeight-1),dark.RGBValue'unten      
    line img, (PosX,PosY+1)-(PosX,PosY+BoxHeight-2),pale.RGBValue'links
    line img, (PosX+BoxWidth-1,PosY+1)-(PosX+BoxWidth-1,PosY+BoxHeight-2),dark.RGBValue'rechts     
  end if
end sub


sub WinFrame (img as FB.Image ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,selected as integer=0)
  dim as ColorInfo fill,dark,shade,colorfx,lightfx
  dim as ulong col
  SetRGB(fill, iif(selected=1,Colors.WinFrame,Colors.WinFrameUnselected)) 
  CalcDark(fill,GradientFX,dark)
  CalcDark(fill,GradientFX*.86,shade)
  CalcPale(fill,GradientFX*.86,lightfx)   
  CalcShiny(fill,GradientFX,colorfx)
  
  GradientFXFill img,0,0,BoxWidth,LeastGap,lightfx.RGBValue,dark.RGBValue,lightfx.RGBValue,dark.RGBValue'oben horizontal
  GradientFXFill img,0,0,LeastGap,BoxHeight,lightfx.RGBValue,lightfx.RGBValue,shade.RGBValue,shade.RGBValue'links vertikal
  GradientFXFill img,BoxWidth-LeastGap,0,LeastGap,BoxHeight,dark.RGBValue,dark.RGBValue,colorfx.RGBValue,colorfx.RGBValue'rechts vertikal    
  GradientFXFill img,0,BoxHeight-LeastGap,BoxWidth,LeastGap,shade.RGBValue,colorfx.RGBValue,shade.RGBValue,colorfx.RGBValue'unten horizontal
  
  if FrameFX then  
    StdFrame img,LeastGap-1,LeastGap-1,BoxWidth-2*LeastGap+2,BoxHeight-2*LeastGap+2,fill.RGBValue,fill.RGBValue,,,1'Innenrahmen  
    StdFrame img,0,0,BoxWidth,BoxHeight,fill.RGBValue,fill.RGBValue,,,0'Aussenrahmen
  end if
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'Boxes


sub StdFilledBox (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0) 
  if FrameFX then
    StdFrame img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover  
    StdFill img,PosX+1,PosY+1,BoxWidth-2,BoxHeight-2,b,s,selected,hover
  else
    StdFill img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover  
  end if
end sub


'Knob Scrollbar
'bleibt immer "erhaben", lediglich "Farbspiel" bei Hover/Selection
sub FilledBoxKnob (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  if FrameFX then
    '#AltFillA img,PosX+1,PosY+1,BoxWidth-2,BoxHeight-2,b,s,selected,hover
    StdFill img,PosX+1,PosY+1,BoxWidth-2,BoxHeight-2,b,s,selected,hover
    StdFrame img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover,0  
  else
    'AltFillA img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
    StdFill img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
  end if
end sub


'Container Scrollbar
sub FilledBoxContainer (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  if FrameFX then 
    StdFrame img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
    AltFillA img,PosX+1,PosY+1,BoxWidth-2,BoxHeight-2,b,s,selected,hover
  else
    AltFillA img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
  end if
end sub


sub FilledBoxDrop (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0,mode as integer=0)
  dim as ulong symbolcolor
  dim as integer asize,a,o
  asize=int(MainWidth*.7)
  a=(BoxWidth-asize)/2
  o=(BoxHeight-int(asize/2) ) /2  
  
  StdFill img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover  
 
  if hover then
    symbolcolor=iif(selected,Colors.HoverFXText,Colors.HoverFXText)
  else
    symbolcolor=Colors.GadText
  end if
  Symbol_Arrow (img,PosX+a,PosY+o,asize,3,symbolcolor)  
end sub


sub FilledBoxList (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
	dim as ColorInfo fill	
  SetRGB(fill, ColorSelection(b, s, selected,hover) )
  'StdFrame img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
	'line img, (PosX+1,PosY+1)-(PosX+BoxWidth-2,PosY+BoxHeight-2),fill.RGBValue,BF
  if FrameFX then
    StdFrame img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
    line img, (PosX+1,PosY+1)-(PosX+BoxWidth-2,PosY+BoxHeight-2),fill.RGBValue,BF  
  else
    line img, (PosX,PosY)-(PosX+BoxWidth,PosY+BoxHeight),fill.RGBValue,BF  
  end if  
end sub


sub FilledBoxEntry (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
	dim as ColorInfo fill	
  SetRGB(fill, ColorSelection(b, s, selected,hover) ) 
  line img, (PosX,PosY)-(PosX+BoxWidth-1,PosY+BoxHeight-1),fill.RGBValue,BF
end sub


sub FilledBoxRadio (img as FB.Image ptr, PosX as integer,PosY as integer,BoxSize as integer,Radius as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  dim as ColorInfo framecolor,lightFX,dark
  dim as ulong dotcolor
  dim as integer d
  d=Boxsize/2
    
  StdFill img,PosX,PosY,BoxSize,BoxSize,b,s,selected,hover
  put img,(PosX,PosY),cast(FB.Image ptr,RadioButtonMask->img),trans
  GetFrameColor(b,s,selected,hover,framecolor)
  
  if FrameFX then  
    if BevelFX then 	      
      CalcPale(framecolor, BevelFX, lightFX)
      CalcDark(framecolor, BevelFX, dark)  
    else 
      SetRGB(lightFX, framecolor.RGBValue) 
      SetRGB(dark, framecolor.RGBValue)    
    end if  
    
    circle img, (PosX+Radius,PosY+Radius), Radius, dark.RGBValue, 0.785, 3.925,1
    circle img, (PosX+Radius,PosY+Radius), Radius, lightFX.RGBValue, 3.926, 0.784,1
  else

  end if
  
  if selected then 
    if hover then
      dotcolor=iif(selected,Colors.HoverFXText,Colors.HoverFXText)
    else
      dotcolor=Colors.GadText
    end if 
    circle img, (PosX+Radius,PosY+Radius), Radius/2, dotcolor,,,,F
  end if
end sub


sub FilledBoxCheckMark (img as FB.Image ptr, PosX as integer,PosY as integer,BoxSize as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  dim as ulong cmcolor
  dim as integer ssize,a,o
  ssize=BoxSize*.6
  a=(MainWidth-ssize)/2

  if FrameFX then
    'AltFillB img,PosX+1,PosY+1,BoxSize-2,BoxSize-2,b,s,selected,hover
    StdFill img,PosX+1,PosY+1,BoxSize-2,BoxSize-2,b,s,selected,hover
    StdFrame img,PosX,PosY,BoxSize,BoxSize,b,s,selected,hover,1	
  else
    'AltFillB img,PosX,PosY,BoxSize,BoxSize,b,s,selected,hover
    StdFill img,PosX,PosY,BoxSize,BoxSize,b,s,selected,hover
  end if

  if selected then 
    if hover then
      cmcolor=iif(selected,Colors.HoverFXText,Colors.HoverFXText)
    else
      cmcolor=Colors.GadText
    end if 
    Symbol_CheckMark (img, PosX+a,PosY+a,ssize,cmcolor)
  end if 	
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'Symbols
sub Symbol_Arrow (img as FB.Image ptr, PosX as integer,PosY as integer,size as integer,direction as integer,col as ulong,thickness as integer=2)
  dim as integer n,w 
  if size<8 then thickness=0
  
  w=size-1  
  if (size mod 2) then
    n=int(size/2)
  else
    n=size/2-1
  end if
  select case direction
    case 0'l
'line img, (PosX,PosY)-(PosX+n,PosY+w),&HFFFFFF,B
      for i as integer=0 to thickness
        line img, (PosX+n,PosY+i)-(PosX+i,PosY+n),col
        line img, (PosX+i,PosY+w-n)-(PosX+n,PosY+w-i),col
      next i
        
    case 1'r
'line img, (PosX,PosY)-(PosX+n,PosY+w),&HFFFFFF,B
      for i as integer=0 to thickness
        line img, (PosX,PosY+i)-(PosX+n-i,PosY+n),col
        line img, (PosX+n-i,PosY+w-n)-(PosX,PosY+w-i),col
      next i

    case 2'up
'line img, (PosX,PosY)-(PosX+w,PosY+n),&HFFFFFF,B
      for i as integer=0 to thickness
        line img, (PosX+i,PosY+n)-(PosX+n,PosY+i),col
        line img, (PosX+w-n,PosY+i)-(PosX+w-i,PosY+n),col
      next i
      
    case 3'dwn
'line img, (PosX,PosY)-(PosX+w,PosY+n),&HFFFFFF,B
      for i as integer=0 to thickness
        line img, (PosX+i,PosY)-(PosX+n,PosY+n-i),col
        line img, (PosX+w-n,PosY+n-i)-(PosX+w-i,PosY),col
      next i
  end select 
end sub


sub Symbol_CheckMark (img as FB.Image ptr, PosX as integer,PosY as integer,size as integer,col as ulong=Colors.Black)
  dim as integer n,w,thickness
  if size<8 then thickness=0 else thickness=2 
  w=size-1  
  if (size mod 2) then
    n=int(size/2)
  else
    n=size/2-1
  end if

  for i as integer=0 to thickness
    line img, (PosX+i,PosY+w-n)-(PosX+n,PosY+w-i),col
    line img, (PosX+n,PosY+w-i)-(PosX+w-i,PosY),col
  next i

end sub


sub Symbol_X (img as FB.Image ptr, PosX as integer,PosY as integer, col as ulong=Colors.Black)
  line img, (PosX+1,PosY+1)-(PosX+6,PosY+6),col
  line img, (PosX+1,PosY+0)-(PosX+7,PosY+6),col
	line img, (PosX+0,PosY+1)-(PosX+6,PosY+7),col
  
  line img, (PosX+1,PosY+6)-(PosX+6,PosY+1),col
  line img, (PosX+0,PosY+6)-(PosX+6,PosY+0),col
	line img, (PosX+1,PosY+7)-(PosX+7,PosY+1),col  
end sub


sub Symbol_Cyclic (img as FB.Image ptr, PosX as integer,PosY as integer, col as ulong=Colors.Black)
  line img, (PosX+0,PosY+2)-(PosX+1,PosY+8),col,BF
  line img, (PosX+7,PosY+2)-(PosX+8,PosY+6),col,BF  
  
  line img, (PosX+2,PosY+0)-(PosX+6,PosY+1),col,BF
	line img, (PosX+2,PosY+9)-(PosX+6,PosY+10),col,BF
  
  line img, (PosX+1,PosY+1)-(PosX+2,PosY+2),col
  line img, (PosX+1,PosY+9)-(PosX+2,PosY+8),col
  line img, (PosX+7,PosY+1)-(PosX+6,PosY+2),col
  'line img, (PosX+7,PosY+9)-(PosX+6,PosY+8),col
  
  'line img, (PosX+7,PosY+8)-(PosX+8,PosY+8),col

  line img, (PosX+5,PosY+4)-(PosX+6,PosY+4),col
  line img, (PosX+9,PosY+4)-(PosX+10,PosY+4),col
  
  pset img, (PosX+6,PosY+5),col
  pset img, (PosX+9,PosY+5),col  
end sub


sub DrawRBMask(img as FB.Image ptr, DrawSize as integer, Radius as integer)
  dim as integer d
  line img, (0,0)-(DrawSize-1,DrawSize-1),Colors.Background,BF  
  circle img, (Radius,Radius), Radius, &HFF00FF,,,,F 
end sub
