namespace sGUI

declare sub DeleteEntries overload(gad as Gadget ptr)
declare sub DeleteEntries(list as sGUIList ptr)

declare function AddEntry overload(gad as Gadget ptr,Text as string="", EType as integer=ETYPE_UNDEFINED, Qualifier as integer=0) as sGUIEntry ptr
declare function AddEntry (list as sGUIList ptr,Text as string="", EType as integer=ETYPE_UNDEFINED, Qualifier as integer=0) as sGUIEntry ptr

declare function GetEntryAddr overload(gad as Gadget ptr,Index as integer) as sGUIEntry ptr
declare function GetEntryAddr(list as sGUIList ptr,Index as integer) as sGUIEntry ptr

declare function GetEntryText overload(gad as Gadget ptr,Index as integer) as string
declare function GetEntryText(list as sGUIList ptr,Index as integer) as string

declare function GetEntryType overload(gad as Gadget ptr,Index as integer) as integer
declare function GetEntryType(list as sGUIList ptr,Index as integer) as integer

declare function GetEntryQualifier overload(gad as Gadget ptr,Index as integer) as integer
declare function GetEntryQualifier(list as sGUIList ptr,Index as integer) as integer

declare sub DirTosGUIList(list as sGUIList ptr,directory as string=exepath,mode as integer=3 )
declare sub DirToListBox(gad as Gadget ptr,directory as string=exepath,mode as integer=3 ) 


sub DeleteEntries(gad as Gadget ptr)
  if gad->xtd.EntryList then    
    gad->xtd.EntryList->DeleteAll    
  end if
end sub


sub DeleteEntries(list as sGUIList ptr)
  list->DeleteAll
end sub


function AddEntry(gad as Gadget ptr,Text as string="", EType as integer=ETYPE_UNDEFINED, Qualifier as integer=0) as sGUIEntry ptr
  function=0
  if gad->xtd.EntryList then    
    'function=AddEntry(gad->xtd.EntryList, Text, Tag, Qualifier) 
    function=AddEntry(gad->xtd.EntryList, Text, EType, Qualifier)     
  end if
end function


function AddEntry(list as sGUIList ptr,Text as string="", EType as integer=ETYPE_UNDEFINED, Qualifier as integer=0) as sGUIEntry ptr
  function=0
  dim as sGUIEntry ptr entry=list->AppendNew(sGUIEntryType)
  if entry then
    entry->Text   =Text  
    'entry->Tag    =Tag
    entry->EntryType=EType
    entry->Qualifier =Qualifier
		function=entry
  end if
end function


function GetEntryAddr(gad as Gadget ptr,Index as integer) as sGUIEntry ptr
  function=0
  if gad->xtd.EntryList then    
    function=GetEntryAddr(gad->xtd.EntryList,Index)
  end if
end function


function GetEntryAddr(list as sGUIList ptr,Index as integer) as sGUIEntry ptr
  dim as sGUIEntry ptr entry,detected
  detected=0
  entry=list->GetFirst
	if Index<>0 then
    if entry then
      do
        if (entry->Index = Index) then detected=entry
        entry=cast(sGUIEntry ptr,entry->next_node)
      loop until (entry=0) or (detected<>0)
    end if
  end if
  function=detected
end  function


function GetEntryText(gad as Gadget ptr,Index as integer) as string
  function=""
  if Index<>0 then
    if gad->xtd.EntryList then    
      function=GetEntryText(gad->xtd.EntryList,Index)
    end if
  end if
end function


function GetEntryText(list as sGUIList ptr,Index as integer) as string
  function=( GetEntryAddr(list,Index) )->Text
end function


function GetEntryType (gad as Gadget ptr,Index as integer) as integer
  function=ETYPE_UNDEFINED
  if gad->xtd.EntryList then    
    function=GetEntryType(gad->xtd.EntryList,Index)
  end if
end function


function GetEntryType(list as sGUIList ptr,Index as integer) as integer
  function=( GetEntryAddr(list,Index) )->EntryType
end function


function GetEntryQualifier (gad as Gadget ptr,Index as integer) as integer
  function=0
  if Index<>0 then
    if gad->xtd.EntryList then    
      function=GetEntryQualifier(gad->xtd.EntryList,Index)
    end if
  end if
end function


function GetEntryQualifier(list as sGUIList ptr,Index as integer) as integer
  function=( GetEntryAddr(list,Index) )->Qualifier
end function



'mode=1 nur Dateien
'mode=2 nur Verzeichnisse
'mode 3 Dateien & Verzeichnisse 
sub DirTosGUIList(list as sGUIList ptr,directory as string=exepath,mode as integer=3 )
  dim as string entryname
  DeleteEntries (list)
  chdir directory
  
  if (mode and 2)=2 then
    'entryname=dir("*",fbDirectory or fbHidden or fbReadOnly or fbSystem)
    entryname=dir("*",fbDirectory or fbHidden or fbReadOnly or fbSystem)
    do
      if (len(entryname)>0) and (entryname<>".") and (entryname<>"..") then
        AddEntry(list,entryname,ETYPE_DIR)
      end if
      entryname=dir
    loop while len(entryname)      
  end if
  
  if (mode and 1)=1 then
    entryname=dir("*",fbNormal)
    do
      if (len(entryname)>0) and (entryname<>".") and (entryname<>"..") then
        AddEntry(list,entryname,ETYPE_FILE)
      end if
      entryname=dir
    loop while len(entryname)     
  end if
end sub


sub DirToListBox(gad as Gadget ptr,directory as string=exepath,mode as integer=3 ) 
  if gad->xtd.EntryList then
    DirTosGUIList(gad->xtd.EntryList,directory,mode)
  end if
end sub

/'
function MenuStart (list as sGUIList ptr, text as string) as integer
  function=cast(integer,AddEntry (list,text,"STRT"))
end function


function AddItem (list as sGUIList ptr, text as string) as integer
  function=cast(integer,AddEntry (list,text,"ITEM"))
end function


function AddCheckMark (list as sGUIList ptr, text as string, selection as integer=1) as integer  
  dim as sGUIEntry ptr entry
  entry=AddEntry (list,text,"CHCK")
  entry->Selection=selection
  function=cast(integer,entry)
end function


function AddSeparator (list as sGUIList ptr) as integer
  function=cast(integer,AddEntry (list,,"SEPR"))
end function


function MenuEnd (list as sGUIList ptr) as integer
  function=cast(integer,AddEntry (list,,"MEND"))
end function
'/

end namespace
