declare sub MasterControlProgram (mode as integer=1)
declare sub DrawScreen

declare sub Gadget_Crawler (win as sGUIWindow ptr=RootWindow, check as integer=0)
declare sub GadgetKeyboard_Crawler

declare sub Selection_Crawler (refwin as sGUIWindow ptr)
declare sub Backdrop_Crawler (win as sGUIWindow ptr=Rootwindow)
declare sub AlwaysOnTop_Crawler (win as sGUIWindow ptr=Rootwindow)
declare sub Warn_Crawler (win as sGUIWindow ptr=Rootwindow)
declare sub DropDownWindow_Crawler (win as sGUIWindow ptr=Rootwindow)
declare sub HideOnOuterClick_Crawler (refwin as sGUIWindow ptr)

declare sub ExtendedActionExecute
declare sub AsParent_Crawler (refwin as sGUIWindow ptr)
declare sub AsParentSelection_Crawler
declare sub Update_Crawler

declare sub GUIBuild_Crawler(win as sGUIWindow ptr)
declare sub Hover_Crawler(warnwin as sGUIWindow ptr)
declare sub DrawGadgets_Crawler

declare function GetWindowPointer(win as sGUIWindow ptr=RootWindow,warnwin as sGUIWindow ptr=0,warnignorewin as sGUIWindow ptr=0) as sGUIWindow ptr
declare function GetWarnWindow as sGUIWindow ptr
declare function GetWarnIgnoreWindow as sGUIWindow ptr
declare function GetParentWindow(child as WinGadHeader ptr) as sGUIWindow ptr


sub MasterControlProgram (mode as integer=1) 
  dim as Gadget ptr childgad
  dim as sGUIWindow ptr parentwin,childwin,warnwin,warnignorewin
  static as sGUIWindow ptr refwin,lastwin
  dim as integer ScrPosX, ScrPosY
  MCPMode=mode
  GetSysEvents
    GADGETMESSAGE=0
    WINDOWMESSAGE=0
    warnwin=GetWarnWindow
    'warnignorewin=GetWarnIgnoreWindow
    
    'hier wird der 4phasige Klickvorgang HIT->HOLD->RELEASE->RELEASED einem Fenster (refwin) zugeordnet
    'ausgehend vom RootWindow bilden alle erzeugten Fenster einen Hierachie-Baum, praktisch ist dies die Z-Ebene
    'ist der Klickvorgang einem Fenster zugeordnet worden dann
    'braucht auch nur noch dessen Gadgetliste untersucht werden (Gadget_Crawler(refwin,0))
    'die Gadgets anderer Fenster werden ignoriert
    'falls sich durch den Klickvorgang nderungen in der Z-Ebene ergeben
    'so werden diese auch hier geregelt (via AlwaysOnTop_Crawler, Backdrop_Crawler, HideOnOuterClick_Crawler und das warnwin Handling)
    select case LMB
    case HIT
      refwin=GetWindowPointer(,warnwin)        
      if refwin then       
        if refwin<>Rootwindow then 
          if (refwin->WinFlags and WFLAG_STACKABLE) then cast(sGUIWindow ptr,refwin->parent)->WindowList->MoveToLast(refwin) 
        end if            
        Selection_Crawler(refwin)       
        HideOnOuterClick_Crawler(refwin)      
        Gadget_Crawler(refwin,0)' LMB Check                
      end if 
      
      Backdrop_Crawler 
      AlwaysOnTop_Crawler
      
    case HOLD,RELEASE
      if refwin then Gadget_Crawler(refwin,0)' LMB Check
   
    case RELEASED
      if refwin then 
        Gadget_Crawler(refwin,0)' LMB Check' Click aufrumen
        lastwin=refwin
        if (refwin->WinFlags and WFLAG_HIDECLICKEDINSIDE) then refwin->Activation=0
        refwin=0
      end if
        
      if warnwin then
        cast(sGUIWindow ptr,warnwin->parent)->WindowList->MoveToLast(warnwin)
        Selection_Crawler(warnwin)
      end if
        
      Backdrop_Crawler   
      AlwaysOnTop_Crawler
      Warn_Crawler
            
      'diverse Abstrze spter...
      'Es sollte immer sichergestellt sein dass das vorhergehend untersuchte "Eingabegert" keine GADGETMESSAGE hinterlassen hat      
      'bevor das nchste gecheckt wird!
      'Sonst wird im darauf folgenden Check die LOOPTHROUGH-Action ausgefhrt, was zum Absturz fhrt. 
      'falls notwendig einen Rettungsanker ala "if GADGETMESSAGE=0 then..." einbauen

      if GADGETMESSAGE=0 then Gadget_Crawler(GetWindowPointer,1)' Wheel Check
      if GADGETMESSAGE=0 then GadgetKeyboard_Crawler' Keyboard Check            
  end select

  ExtendedActionExecute
  AsParent_Crawler (WINDOWMESSAGE)
  AsParentSelection_Crawler    
  Update_Crawler
  if (HoverFX=1) then Hover_Crawler(warnwin)
  if mode then DrawScreen 
end sub


sub DrawScreen
  DrawGadgets_Crawler   
  GUIBuild_Crawler (RootWindow)'komplette GUI ins RootWindow Image zeichnen
  sGUIScreenSet 1,1
    screenlock
      screencopy 0,1      
      put (0,0),RootWindow->DrawBuffer->img,trans
    screenunlock
  sGUIScreenSet 0,1
end sub


'Gadget_Crawler() geht durch die GadgetList eines Fensters und
'verknpft Ereignisse mit den in der Liste befindlichen Gadgets
'Sollte ein Gadget selbst ein Fenster haben, erfolgt ein rekursiver Aufruf
'Somit werden bei zusammengesetzten Gadgets alle Ebenen durchlaufen
'check=0 win->LMBGadgetCheck
'check=1 win->WheelGadgetCheck
'check=2 win->KeyboardGadgetCheck
sub  Gadget_Crawler (win as sGUIWindow ptr=RootWindow, check as integer=0)
  dim as Gadget ptr childgad

  childgad=win->GadgetList->GetFirst
  if childgad then
    do
      if childgad->GadgetWindow then Gadget_Crawler(childgad->GadgetWindow, check)'<<<----!!!!
      childgad=cast(Gadget ptr,childgad->next_node)
    loop until (childgad=0) or (GADGETMESSAGE<>0)'Abbruch wenn ein Ereignis auftrat
  end if 
  
  
 if WINDOWMESSAGE then'!!!reagieren auf globale WINDOWMESSAGE, die nur aus einem GadWindow (d.h. einem zusammengesetztes Gadget) stammen kann
    
    win->LoopThroughCheck
    
  else
  
    select case check
      case 0
        win->LMBGadgetCheck
      case 1
        win->WheelGadgetCheck
      case 2
        win->KeyboardGadgetCheck
        
    end select
    
  end if
  
  'sollte im untersuchten Fenster ein Ereignis festgestellt worden sein, dieses an die globale Variable "durchschleifen" 
  if win->GADMESSAGE then 
    GADGETMESSAGE=win->GADMESSAGE
    WINDOWMESSAGE=win
  else
    GADGETMESSAGE=0
    WINDOWMESSAGE=0 
  end if
end sub


sub GadgetKeyboard_Crawler
  dim as sGUIList ptr lst
  dim as sGUIWindow ptr win
  'if (GADGETMESSAGE=0) and (KEY<>"") then
    lst=WindowLists->GetFirst 
    if lst then
      do
        win=lst->GetFirst
        if win then
          do
            if win->Activation then
              'if win->Selection then Gadget_Crawler (win,2)
              Gadget_Crawler (win,2)
            end if
            win=cast(sGUIWindow ptr,win->next_node)
          loop until (win=0) or (GADGETMESSAGE<>0)
        end if
        lst=cast(sGUIList ptr,lst->next_node)
      loop until (lst=0) or (GADGETMESSAGE<>0)
    end if
  'end if
end sub


'ohne Rekursion
sub Selection_Crawler (refwin as sGUIWindow ptr)
  dim as sGUIList ptr lst
  dim as sGUIWindow ptr win
  if (refwin->WinFlags and WFLAG_NOSELECT)=0 then 
    lst=WindowLists->GetFirst
    if lst then
      do
        win=lst->GetFirst
        if win then
          do
            if win->Activation then
              win->Selection=iif(win=refwin,1,0)
            end if
            win=cast(sGUIWindow ptr,win->next_node)
          loop until win=0
        end if
        lst=cast(sGUIList ptr,lst->next_node)
      loop until lst=0
    end if
  end if  
end sub


sub Backdrop_Crawler (win as sGUIWindow ptr=Rootwindow)
  dim as _sGUIWindow ptr childwin
  dim as sGUIList ptr WindowPointerList
  dim as node ptr n
  
  childwin=win->WindowList->GetLast'WindowPointerList rckwrts durchsuchen
  if childwin then                                                      
    'Erzeugen einer IndexList, die die Pointer aller BACKDROP Fenster aufnimmt    
    WindowPointerList=PointersLists->AppendNew (sGUIListType) 
    'Suche nach BACKDROP
    'bei mehreren BACKDROP bleibt deren Reihenfolge relativ zueinander erhalten    
    
    do
      if childwin->Activation=1 then
        if (childwin->WinFlags and WFLAG_BACKDROP) then 'wenn ein BACKDROP gefunden wurde, merken wir uns dieses in der WindowPointerList
          n=WindowPointerList->AppendNew (nodeType)
          n->anypointer=cast(any ptr,childwin)
        end if
      end if
      childwin=cast(sGUIWindow ptr,childwin->prev_node)
    loop until childwin=0
    
    'wenn ein oder mehrere BACKDROP gefunden wurde, diese jetzt nach unten (genauer gesagt zum Anfang der Liste) verschieben
    n=WindowPointerList->GetFirst
    if n then
      do
        win->WindowList->MoveToFirst( cast(sGUIWindow ptr, n->anypointer)  )
        n=cast(node ptr,n->next_node)
      loop until n=0
    end if
    
    'IndexListe lschen
    PointersLists->DeleteNode(WindowPointerList)
    
    'Nach Sortierung rekursiver Aufruf
    childwin=win->WindowList->GetFirst
    do
      if childwin->Activation=1 then Backdrop_Crawler(childwin)         
      childwin=cast(sGUIWindow ptr,childwin->next_node)
    loop until childwin=0
  end if 
end sub


sub AlwaysOnTop_Crawler (win as sGUIWindow ptr=Rootwindow)
  dim as _sGUIWindow ptr childwin
  dim as sGUIList ptr WindowPointerList
  dim as node ptr n
  
  childwin=win->WindowList->GetFirst
  if childwin then                                               
        
    'Erzeugen einer IndexList, die die Pointer aller ALWAYSONTOP Fenster aufnimmt
    
    WindowPointerList=PointersLists->AppendNew (sGUIListType) 
    'Suche nach ALWAYSONTOP
    'bei mehreren ALWAYSONTOP bleibt deren Reihenfolge relativ zueinander erhalten    
    do
      'if childwin->Activation=1 then
        if (childwin->WinFlags and WFLAG_ALWAYSONTOP) then 'wenn ein ALWAYSONTOP gefunden wurde, merken wir uns dieses in der WindowPointerList
          n=WindowPointerList->AppendNew (nodeType)
          n->anypointer=cast(any ptr,childwin)
        end if
      'end if
      childwin=cast(sGUIWindow ptr,childwin->next_node)
    loop until childwin=0
    
    'wenn ein oder mehrere ALWAYSONTOP gefunden wurde, diese jetzt nach oben verschieben
    n=WindowPointerList->GetFirst
    if n then
      do
        win->WindowList->MoveToLast( cast(sGUIWindow ptr, n->anypointer)  )
        n=cast(node ptr,n->next_node)
      loop until n=0
    end if
    
    'IndexListe lschen
    PointersLists->DeleteNode(WindowPointerList)
    
    'Nach Sortierung rekursiver Aufruf
    childwin=win->WindowList->GetFirst
    do
      if childwin->Activation=1 then AlwaysOnTop_Crawler(childwin)         
      childwin=cast(sGUIWindow ptr,childwin->next_node)
    loop until childwin=0
  end if 
end sub


sub Warn_Crawler (win as sGUIWindow ptr=Rootwindow)
  dim as _sGUIWindow ptr childwin
  dim as sGUIList ptr WindowPointerList
  dim as node ptr n
  
  childwin=win->WindowList->GetFirst
  if childwin then                                               
        
    'Erzeugen einer IndexList, die die Pointer aller WARN Fenster aufnimmt
    
    WindowPointerList=PointersLists->AppendNew (sGUIListType) 
    
    'Suche nach WARN
    'bei mehreren WARN bleibt deren Reihenfolge relativ zueinander erhalten    
    do
      'if childwin->Activation=1 then
        if (childwin->WinFlags and WFLAG_WARN) then 'wenn ein WARN gefunden wurde, merken wir uns dieses in der WindowPointerList
          n=WindowPointerList->AppendNew (nodeType)
          n->anypointer=cast(any ptr,childwin)
        end if
      'end if
      childwin=cast(sGUIWindow ptr,childwin->next_node)
    loop until childwin=0
     
    'wenn ein oder mehrere WARN gefunden wurde, diese jetzt nach oben verschieben
    n=WindowPointerList->GetFirst
    if n then
      do
        win->WindowList->MoveToLast( cast(sGUIWindow ptr, n->anypointer)  )
        n=cast(node ptr,n->next_node)
      loop until n=0
    end if
    
    'IndexListe lschen
    PointersLists->DeleteNode(WindowPointerList)
    
  /' 
    'Nach Sortierung rekursiver Aufruf
    childwin=win->WindowList->GetFirst
    do
      if childwin->Activation=1 then DropDown_Crawler(childwin)         
      childwin=cast(sGUIWindow ptr,childwin->next_node)
    loop until childwin=0
  '/
  
  end if

end sub


sub WarnIgnoreWindow_Crawler (win as sGUIWindow ptr=Rootwindow)
  dim as _sGUIWindow ptr childwin
  dim as sGUIList ptr WindowPointerList
  dim as node ptr n
  
  childwin=win->WindowList->GetFirst
  if childwin then                                               
        
    'Erzeugen einer IndexList, die die Pointer aller WARN Fenster aufnimmt
    
    WindowPointerList=PointersLists->AppendNew (sGUIListType) 
    
    'Suche nach DROPDOWN
    'bei mehreren DROPDOWN bleibt deren Reihenfolge relativ zueinander erhalten    
    do
      'if childwin->Activation=1 then
        if (childwin->WinFlags and WFLAG_WARNIGNORE) then 'wenn ein DROPDOWN gefunden wurde, merken wir uns dieses in der WindowPointerList
          n=WindowPointerList->AppendNew (nodeType)
          n->anypointer=cast(any ptr,childwin)
        end if
      'end if
      childwin=cast(sGUIWindow ptr,childwin->next_node)
    loop until childwin=0
     
    'wenn ein oder mehrere WARN gefunden wurde, diese jetzt nach oben verschieben
    n=WindowPointerList->GetFirst
    if n then
      do
        win->WindowList->MoveToLast( cast(sGUIWindow ptr, n->anypointer)  )
        n=cast(node ptr,n->next_node)
      loop until n=0
    end if
    
    'IndexListe lschen
    PointersLists->DeleteNode(WindowPointerList)
  /' 
    'Nach Sortierung rekursiver Aufruf
    childwin=win->WindowList->GetFirst
    do
      if childwin->Activation=1 then DropDown_Crawler(childwin)         
      childwin=cast(sGUIWindow ptr,childwin->next_node)
    loop until childwin=0
  '/
  
  end if
end sub


sub HideOnOuterClick_Crawler (refwin as sGUIWindow ptr)
  dim as sGUIList ptr lst
  dim as sGUIWindow ptr win
  lst=WindowLists->GetFirst
  if lst then
    do
      win=lst->GetFirst
      if win then
        do
          if (win<>refwin) then
            'schliesse alle AUTOHIDE-Fenster mit Ausnahme des Referenzfensters, welches auch ein AUTOHIDE sein knnte, aber nicht muss
            if (win->WinFlags and WFLAG_HIDECLICKEDOUTSIDE) then win->Activation=0          
          end if
          win=cast(sGUIWindow ptr,win->next_node)
        loop until win=0
      end if
      lst=cast(sGUIList ptr,lst->next_node)
    loop until lst=0
  end if 
end sub


sub ExtendedActionExecute
  dim as ExtendedAction ptr xaction
  xaction=ExtendedActionList->GetFirst
  if xaction then
    do
      if (GADGETMESSAGE<>0) and (GADGETMESSAGE=xaction->cause_gad) then xaction->DoExtendedAction(xaction)    
      if (WINDOWMESSAGE<>0) and (WINDOWMESSAGE=xaction->cause_win) then xaction->DoExtendedAction(xaction)
      xaction=cast(ExtendedAction ptr,xaction->next_node)
    loop until xaction=0
  end if
end sub


sub AsParent_Crawler (win as sGUIWindow ptr)
  if win then
    WINDOWMESSAGE=win'sieht beim Einstieg doof aus, da ja WINDOWMESSAGE als Parameter bergeben wurde... erst in der Rekursion ergibt es einen Sinn
    if (win->WinFlags and WFLAG_PARENTSELECT) then AsParent_Crawler(cast(sGUIWindow ptr,win->parent))  
  end if
end sub

sub AsParentSelection_Crawler
  dim as sGUIList ptr lst
  dim as sGUIWindow ptr win,parent
  dim as integer flag
  lst=WindowLists->GetFirst
  if lst then
    do
      win=lst->GetFirst
      if win then
        do     
          
          parent=win'das sieht jetzt etwas komisch aus, macht den Einstieg in den folgenden Loop aber leichter
          flag=parent->WinFlags and WFLAG_PARENTSELECT
          if parent->Selection then
            do
              if (flag<>0) and (parent->Selection=1) then 
                parent->Selection=0
                parent=cast(sGUIWindow ptr,parent->parent)
                if parent then
                  parent->Selection=1
                  flag=parent->WinFlags and WFLAG_PARENTSELECT
                end if
              end if                     
            loop until (flag=0) or (parent=0)
          end if
          win=cast(sGUIWindow ptr,win->next_node)
        loop until win=0
      end if
      lst=cast(sGUIList ptr,lst->next_node)
    loop until lst=0
  end if   
end sub

sub Update_Crawler
  dim as sGUIList ptr lst
  dim as Gadget ptr gad
  lst=GadgetLists->GetFirst
  if lst then
    do
      gad=lst->GetFirst
      if gad then
        do
          if gad->Activation then UpdateGadget(gad)
          'UpdateGadget(gad)
          gad=cast(Gadget ptr,gad->next_node)
        loop until gad=0
      end if
      lst=cast(sGUIList ptr,lst->next_node)
    loop until lst=0
  end if 
end sub


sub Hover_Crawler(warnwin as sGUIWindow ptr)
  dim as sGUIList ptr lst
  dim as Gadget ptr gad
  dim as sGUIWindow ptr win,gadwin
  '1.) alle Gadgets "unhovern", mal nichts rekursives da alle Gadgets in double linked Listen sind :)
  lst=GadgetLists->GetFirst
  if lst then
    do
      gad=lst->GetFirst
      if gad then
        do
          gad->MouseHover=0
          gad=cast(Gadget ptr,gad->next_node)
        loop until gad=0
      end if
      lst=cast(sGUIList ptr,lst->next_node)
    loop until lst=0
  end if
  
  '2.)Fenster aus Fensterhierachie, ber welchem die Maus schwebt (Funktion ist rekursiv)
  win=GetWindowPointer(,warnwin) 
   
  
  '3.)alle GadgetWindows berprfen
  gadwin=GadgetWindowList->GetFirst
  if gadwin then
    do
      'verwandschaftliche Beziehung win<->gadwin ermitteln,
      'also ist das gadwin ber einen oder mehrere Parent-Gadgets Bestandteil des "echten" Windows win. 
      'wenn ja dann die Hoverroutine aufrufen    
      if GetParentWindow(gadwin)=win then gadwin->HoveringOverGadgetCheck  
      gadwin=cast(sGUIWindow ptr,gadwin->next_node)
    loop until (gadwin=0)   
  end if    
   
  win->HoveringOverGadgetCheck  
   
end sub


sub DrawGadgets_Crawler
  dim as sGUIList ptr lst
  dim as Gadget ptr gad
  lst=GadgetLists->GetFirst
  if lst then
    do
      gad=lst->GetFirst
      if gad then
        do
          if DrawRequest(gad) then gad->DoDraw (gad)'DrawGadget(gad)
          gad=cast(Gadget ptr,gad->next_node)
        loop until gad=0
      end if
      lst=cast(sGUIList ptr,lst->next_node)
    loop until lst=0
  end if 
end sub


sub GUIBuild_Crawler(win as sGUIWindow ptr)
  dim as Gadget ptr childgad,parentgad
  dim as sGUIWindow ptr childwin,parentwin
  dim as sGUIList ptr lst
    
  'Fensteraufbau im fenstereigenen Image:
  '1. "Saubermachen" und UserGFX hineinkopieren
   win->DoClearWindow (win)
  
  '2. Child-Gagdets ins Fenster kopieren
  'Loop durch die GadgetList dieses Fensters 
  lst=win->GadgetList
  childgad=lst->GetFirst  
  if childgad then
    do             
      if childgad->GadgetWindow then GUIBuild_Crawler(childgad->GadgetWindow)
      'nach Rckkehr aus dem rekursiven Aufruf ist sichergestellt, dass sich alle
      '"Kinder und KindesKinder" im GadgetWindow des aktuellen ChildGadgets verewigt haben
      if childgad->Activation then
        'GFX des Gadgets nur dann in sein ParentFenster kopieren, wenn dieses KEIN GadgetFenster hat:
        if childgad->GadgetWindow=0 then
          put win->DrawBuffer->img,(win->ContentOffsetX + childgad->PosX, win->ContentOffsetY + childgad->PosY),childgad->DrawBuffer->img,trans'pset           
        else'anderenfalls, also es gibt EIN Gadgetfenster, wird dieses direkt ins Parentfenster des Gadgets kopiert
          put win->DrawBuffer->img,(win->ContentOffsetX + childgad->PosX, win->ContentOffsetY + childgad->PosY),childgad->GadgetWindow->DrawBuffer->img,trans'pset
        end if
      end if
      'nchstes Gadget holen
      childgad=cast(Gadget ptr,childgad->next_node)

    loop until childgad=0
  end if   
  
  '3.ChildWindows erstellen (rekursiv), diese kopieren sich dann selbst nach "unten" ins Image seines Parents
  'Loop durch die WindowList dieses Fensters
  childwin=win->WindowList->GetFirst
  if childwin then
    do
      'if childwin->Activation then GUIBuild_Crawler(childwin)
      GUIBuild_Crawler(childwin)
      childwin=cast(sGUIWindow ptr,childwin->next_node)
    loop until childwin=0
  end if
  
  '4. Rahmen ins Fenster zeichnen, soweit einer existieren soll
  win->DoDrawWindow (win)
  
  '5. fenstereigene Gadgets in Fenster kopieren(Drag/Close)
  'Loop durch die WinGadgetList dieses Fensters 
  lst=win->WinGadgetList
  childgad=lst->GetFirst  
  if childgad then
    do
      if childgad->Activation then'also ON und SLEEP als Activation                  
        if childgad->DrawBuffer->img then 
          childgad->DoDraw (childgad)'DrawGadget(childgad)
          put win->DrawBuffer->img,(win->ContentOffsetX + childgad->PosX, win->ContentOffsetY + childgad->PosY),childgad->DrawBuffer->img,trans'pset     
        end if
      end if
      childgad=cast(Gadget ptr,childgad->next_node)            
    loop until childgad=0
  end if  
  
  '6. das nun fertige Fenster in sein Parent kopieren (betrifft Aussage in Step 3)  
  if win->parent then' wenn es das RootWindow betrifft, geschieht nichts da ein RootWindow kein Parent hat 
    if win->Activation then
      parentwin=cast(sGUIWindow ptr,win->parent)
      put parentwin->DrawBuffer->img,(parentwin->ContentOffsetX + win->PosX, parentwin->ContentOffsetY + win->PosY),win->DrawBuffer->img,pset'alpha       
    end if
  end if
end sub


'******************************************************************************
function GetWindowPointer(win as sGUIWindow ptr=RootWindow,warnwin as sGUIWindow ptr=0,warnignorewin as sGUIWindow ptr=0) as sGUIWindow ptr
  dim as _sGUIWindow ptr childwin,hoverwin,tmp
  dim as integer WinX,WinY
  GetGlobalPosition(win,WinX,WinY) 
  hoverwin=win
   
  if warnwin then
      
    hoverwin=warnwin
    
  else
  
    childwin=win->WindowList->GetFirst
    if childwin then
      do
        if childwin->Activation then'nur bei Activation=1 gibt es eine Antwort        
          if (MOUSEX >= WinX+childwin->PosX) and (MOUSEX < WinX+childwin->PosX+childwin->WinWidth) and _
             (MOUSEY >= WinY+childwin->PosY) and (MOUSEY < WinY+childwin->PosY+childwin->WinHeight) then
             hoverwin=childwin        
          end if
        end if  
        childwin=cast(sGUIWindow ptr,childwin->next_node)
      loop until childwin=0
    end if
    if hoverwin<>win then hoverwin=GetWindowPointer(hoverwin,0,0)'rekursiver Aufruf ohne warn/warnignore
    
  end if
  
  function=hoverwin
end function


'ausgehend von einem GadgetWindow wird nach dem "echten" Elternfenster gesucht
function GetParentWindow(examined as WinGadHeader ptr) as sGUIWindow ptr
  dim as WinGadHeader ptr parent
  dim as integer result=0
  if examined<>RootWindow then
    do
      examined=examined->parent
      if examined=RootWindow then
        result=1
      else
        parent=examined->parent
        if (examined->KindOfType=0) and (parent->KindOfType=0) then result=1      
      end if     
    loop until result=1
  end if
  function=cast(sGUIWindow ptr,examined)
end function


function GetWarnWindow as sGUIWindow ptr
  dim as sGUIList ptr lst
  dim as sGUIWindow ptr win,warnwin
  warnwin=0
  lst=WindowLists->GetFirst
  if lst then
    do
      win=lst->GetFirst
      if win then
        do
          if win->Activation then
            if (win->WinFlags and WFLAG_WARN) then 
              if warnwin then
                if win->ActiveSince >= warnwin->ActiveSince then warnwin=win
              else
                warnwin=win
              end if
            end if
          end if
          win=cast(sGUIWindow ptr,win->next_node)
        loop until (win=0)
      end if
      lst=cast(sGUIList ptr,lst->next_node)
    loop until (lst=0)
  end if
   
  function=warnwin
end function


function GetDropDownWindow as sGUIWindow ptr
  dim as sGUIList ptr lst
  dim as sGUIWindow ptr win,dropdownwin
  dropdownwin=0
  lst=WindowLists->GetFirst
  if lst then
    do
      win=lst->GetFirst
      if win then
        do
          if win->Activation then
            if (win->WinFlags and WFLAG_WARNIGNORE) then 
              if dropdownwin then
                if win->ActiveSince >= dropdownwin->ActiveSince then dropdownwin=win
              else
                dropdownwin=win
              end if
            end if
          end if
          win=cast(sGUIWindow ptr,win->next_node)
        loop until (win=0)
      end if
      lst=cast(sGUIList ptr,lst->next_node)
    loop until (lst=0)
  end if
   
  function=dropdownwin
end function


'******************************************************************************
