declare sub KillWindow (win as _sGUIWindow ptr)
declare sub KillGadget (gad as _Gadget ptr)
declare function GetUserImage (win as _sGUIWindow ptr=0) as FB.Image ptr

declare function DrawRequest (gad as _Gadget ptr) as integer
declare sub UpdateGadget(gad as _Gadget ptr)
declare sub GadgetOn    (gad as _Gadget ptr)
declare sub GadgetSleep (gad as _Gadget ptr)
declare sub GadgetOff   (gad as _Gadget ptr)
declare sub RestoreActivation overload (gad as _Gadget ptr)
declare sub ModifyActivation (gad as _Gadget ptr, mode as integer=ACTIVATION_OFF)
declare function GetSelect (gad as _Gadget ptr) as integer
declare sub SetSelect (gad as _Gadget ptr,Selection as integer=1)

declare sub ShowWindow    (win as _sGUIWindow ptr)
declare sub HideWindow    (win as _sGUIWindow ptr)
declare sub DeleteWindow  (win as _sGUIWindow ptr)

declare sub GetGlobalPosition(entity as any ptr, byref posx as integer, byref posy as integer)


'******************************************************************************
'******************************************************************************
'******************************************************************************
type WinGadHeader extends node
  parent      as any ptr'Zeiger auf ein Parent, dies kann beides sein: Window oder Gadget
  KindOfType  as integer'Flag 0=Window,1=Gadget. Nur zur Sicherheit, mal sehen ob es gebraucht wird 
  PosX        as integer
  PosY        as integer
  Text        as string     'Text / Bezeichnung
  
  xtd					as _ExtendedData' ersetzt jetzt das Ctrl()Array durch ne fette UNION
  
  'sGUIImage, dorthinein wird das Gadget/Window gezeichnet
  DrawBuffer    as _sGUIImage ptr

  Selection       as integer
  Activation      as integer
  Activation_Old  as integer
end type


'******************************************************************************
'******************************************************************************
'******************************************************************************
type Gadget extends WinGadHeader
  GadWidth    		as integer    'Gadgetbreite
  GadHeight   		as integer    'Gadgethhe  
 
  DoDraw      		as sub      (gad as Gadget ptr)                                                      'Platzhalter Zeichenroutine
  DoAction    		as function (refgad as Gadget ptr, action as integer=GADGET_LOOPTHROUGH) as integer  'Platzhalter fr Ereignis-Routine  
  DoUpdate    		as sub      (gad as Gadget ptr)                                                      'Platzhalter Update
  
  GadgetWindow 		as _sGUIWindow ptr'ein Gadget darf ein Fenster enthalten   

	'xtd							as _ExtendedData' ersetzt jetzt das Ctrl()Array durch ne fette UNION				
  MouseHover      as integer
  ReDraw          as integer
  oldFlags        as integer
  declare constructor
  declare destructor    
end type


constructor Gadget
  KindOfType=1'its a Gadget
  DrawBuffer =ImageList->AppendNew(sGUIImageType)'leer, noch ohne Image!
  DoUpdate  =@FakeGad
  DoDraw    =@FakeGad
  ReDraw    =1
end constructor


destructor Gadget 
end destructor


'******************************************************************************
'******************************************************************************
'******************************************************************************
type sGUIWindow extends WinGadHeader
  WinFlags        as uinteger
  WinWidth        as integer
  WinHeight       as integer
  ContentOffsetX  as integer
  ContentOffsetY  as integer
  ContentWidth    as integer
  ContentHeight   as integer
  Created         as double
  ActiveSince     as double
  
  GADMESSAGE      as _Gadget ptr'Nummer(genauer Pointer) des Gadgets, welches nen "Ping" von sich gibt
  loopthroughgad  as _Gadget ptr'

  private:
  'Gadget Zeugs
  refgad         as _Gadget ptr 'Referenz Gadget, auf dem der Rest des Clickvorganges basiert
  actgad         as _Gadget ptr
  wheelgad       as _Gadget ptr
	keygad         as _Gadget ptr 

  'letzter abgearbeiteter Tastenstatus der Maus im EventHandle
  lastLMB        as integer
  lastMMB        as integer
  lastRMB        as integer
   
  public:
  'zweites Image, falls User in das Window zeichnen darf, derzeit nur bei Windows mglich
  UserGFXBuffer as _sGUIImage ptr
  
  WinGadgetList as sGUIList ptr
  GadgetList as sGUIList ptr
  WindowList as sGUIList ptr
  
  DoClearWindow		  as sub      (win as sGUIWindow ptr)                                    
  DoDrawContent     as sub      (win as sGUIWindow ptr)  
  DoDrawWindow      as sub      (win as sGUIWindow ptr) 

  DoAction    as function (refwin as sGUIWindow ptr, action as integer) as integer    'Platzhalter fr Ereignis-Routine
  DoUpdate    as sub      (win as sGUIWindow ptr)                                     'Platzhalter Update
  
  declare constructor ()
  declare destructor ()

  declare sub LMBGadgetCheck
  declare sub MMBGadgetCheck 
  declare sub RMBGadgetCheck
  declare sub KeyboardGadgetCheck
  declare sub WheelGadgetCheck  
  declare sub LoopThroughCheck    
  declare sub HoveringOverGadgetCheck
  declare sub LostFocus
  declare function GetGadgetPointer as _Gadget ptr
end type


constructor sGUIWindow
  KindOfType  = 0'its a Window
  WinGadgetList  = GadgetLists->AppendNew(sGUIListType)
  GadgetList  = GadgetLists->AppendNew(sGUIListType)
  WindowList  = WindowLists->AppendNew(sGUIListType)   
  DrawBuffer  = ImageList->AppendNew(sGUIImageType)'leer, noch ohne Image!
  UserGFXBuffer = ImageList->AppendNew(sGUIImageType)'leer, noch ohne Image!
  DoClearWindow=@FakeWin
  DoDrawContent=@FakeWin
  DoDrawWindow=@FakeWin
end constructor


destructor sGUIWindow
end destructor

'Methoden

sub sGUIWindow.LMBGadgetCheck
  dim as integer result,action
  GADMESSAGE=0
  action=0
   
  'Gadgetaktionen fr linken Maustaste
  select case LMB
    case HIT 'wenn Maus grad gedrckt wurde
      refgad=0           'Variablen zurcksetzen
      actgad=0
      result=0
      refgad=GetGadgetPointer
      if refgad then action=GADGET_LMBHIT

    case HOLD
      if refgad then
        actgad=GetGadgetPointer
        if actgad=refgad then action=GADGET_LMBHOLD else action=GADGET_LMBHOLDOFF
      end if

    case RELEASE
      if refgad then
        actgad=GetGadgetPointer
        if actgad=refgad then action=GADGET_LMBRELEASE else action=GADGET_LMBRELEASEOFF
      end if

    case RELEASED
      refgad=0
      
  end select
  'lastLMB=LMB

  if action then result=refgad->DoAction(refgad,action)
  if (result>0) then GADMESSAGE=refgad

  'Keyboard ins Control ausschalten
  if ( (keygad>0) and (refgad>0) and (refgad<>keygad) )  or  (  (keygad>0) and (LMB=HIT) and (refgad=0)  ) then
    
    keygad->DoAction(keygad,GADGET_KEYBOARDOFF)
    keygad=0   
  
  end if

  
  'Keyboard ins Control einschalten
  if result=-1 then keygad=refgad
  

end sub


sub sGUIWindow.WheelGadgetCheck
  dim as integer result
  GADMESSAGE=0    
  'Gadgetaktionen fr Mausrad
  if WHEEL<>0 then
    wheelgad=GetGadgetPointer
    if (wheelgad>0) then 
      result=wheelgad->DoAction(wheelgad,GADGET_WHEELMOVE)
      if (result<>0) then GADMESSAGE=wheelgad
    end if
  end if   
end sub


sub sGUIWindow.KeyboardGadgetCheck
  dim as integer result
  GADMESSAGE=0

  'Fensterwechsel hebt Keyboardstream auf
  if (Selection=0) and (keygad>0) then
    keygad->DoAction(keygad,GADGET_KEYBOARDOFF)
    keygad=0
  end if  
   
  if (KEY<>"") and (keygad>0) then
    if (keygad->Activation=1) then result=keygad->DoAction(keygad,GADGET_KEYBOARD)
    if result<>0 then GADMESSAGE=keygad
    'bei -1 hebt das Gadget den Keyboardstream selbst auf
    if result=-1 then
      keygad->DoAction(keygad,GADGET_KEYBOARDOFF)
      keygad=0
    end if
  end if
end sub


sub sGUIWindow.LoopThroughCheck
  dim as integer result
  loopthroughgad=cast(Gadget ptr,WINDOWMESSAGE->parent)
  if loopthroughgad then
    result=loopthroughgad->DoAction(loopthroughgad,GADGET_LOOPTHROUGH)
    if result then
      GADMESSAGE=loopthroughgad       
    else
      GADMESSAGE=0       
    end if
    if (keygad>0) and (loopthroughgad>0) and (keygad<>loopthroughgad) then
      keygad->DoAction(keygad,GADGET_KEYBOARDOFF)
      keygad=0
    end if     
  end if
end sub


sub sGUIWindow.HoveringOverGadgetCheck 
  dim as Gadget ptr childgad, hovergad

  hovergad=GetGadgetPointer  
 'Loop durch die WinGadgetList....  
  childgad=WinGadgetList->GetFirst  
  if childgad then
    do
      if hovergad then
        if hovergad=childgad then 
          childgad->DoAction(childgad,GADGET_MOUSEHOVER) 
        else 
          childgad->DoAction(childgad,GADGET_MOUSENEXT)
        end if
      else
        childgad->DoAction(childgad,GADGET_MOUSENEXT)
      end if
      'nchstes Gadget
      childgad=cast(Gadget ptr,childgad->next_node)
    loop until childgad=0
  end if
  '... und GadgetList dieses Fensters
  childgad=GadgetList->GetFirst  
  if childgad then
    do
      if hovergad then
        if hovergad=childgad then
          childgad->DoAction(childgad,GADGET_MOUSEHOVER)
        else
          childgad->DoAction(childgad,GADGET_MOUSENEXT)
        end if  
      else
        childgad->DoAction(childgad,GADGET_MOUSENEXT)
      end if
      'nchstes Gadget
      childgad=cast(Gadget ptr,childgad->next_node)
    loop until childgad=0    
  end if   
end sub


sub sGUIWindow.LostFocus
  if keygad then
    keygad->DoAction(keygad,GADGET_KEYBOARDOFF)
    keygad=0
  end if
end sub


function sGUIWindow.GetGadgetPointer as _Gadget ptr
  dim as _Gadget ptr gad,hover
  dim as integer guix,guiy,gadx,gady
  dim as sGUIList ptr sGUIList
  function=0  
  GetGlobalPosition(@this,guix,guiy)
  
  sGUIList=WinGadgetList
  if sGUIList->GetFirst=0 then sGUIList=GadgetList
  gad=sGUIList->GetFirst
  if gad then
    do
      gadx=guix + gad->posx
      gady=guiy + gad->posy
      hover=0
      if gad->Activation=1 then'nur bei Activation=1 gibt es eine Antwort
        if  (MOUSEX>=gadx) and (MOUSEX<gadx + gad->GadWidth) and (MOUSEY>=gady) and (MOUSEY<gady + gad->GadHeight) then
          'MaskenHandling erst einmal herausgenommen!!!!
          'wenn eine Maske existiert, dann ausschliessen ob die Maus-Position
					'nicht ber einem Pixel mit der Farbe RGB(255,0,255) ist!
					'if (gad->Mask>0) then
          '  col=point(MOUSEX-gadx,MOUSEY-gady,gad->Mask->img)
          '  if col<>&HFFFF00FF then hover=gad
					'else'ohne Maske
						hover=gad
					'end if
      	end if
			end if
      if hover then function=gad
    
      'nchstes gad   
      gad=cast(Gadget ptr,gad->next_node)
      'und sGUIListenwechselhandling
      select case sGUIList
        case WinGadgetList
          if gad=0 then 
            sGUIList=GadgetList'<--!!!
            gad=sGUIList->GetFirst
          end if
        'case..... bei mehr als 2 sGUIListen
      end select      
      
    loop until (gad=0) or (hover>0)
  end if
  
end function

'******************************************************************************
'******************************************************************************
'******************************************************************************

sub KillWindow (win as _sGUIWindow ptr)
  dim as Gadget ptr childgad
  dim as sGUIWindow ptr  childwin
  dim as sGUIList ptr owner
  
  'falls dieses Window selbst Childwindows hat
  'KillWindow fr jedes der Fenster in der WindowList rekursiv aufrufen
  childwin=win->WindowList->GetFirst
  if childwin then
    do
      KillWindow(childwin)
      childwin=cast(sGUIWindow ptr,win->WindowList->GetFirst)'bei jedem Durchgang wird immer der erste Eintrag der WindowList wird entfernt
    loop until childwin=0
  end if
  'Die nun zwar leere WindowList selbst muss aber auch aus einer bergeordneten sGUIListe entfernt werden
  'hier wre der owner eigentlich bekannt, eine WindowList eines Fensters wird immer in der globalen sGUIListe "WindowLists" erzeugt(sGUI.bas)
  'WindowLists->DeleteNode(win->WindowList)' wre also der einfachste Weg
  'wir gehen aber ber den owner im geerbten node
  owner=win->WindowList->owner
  owner->DeleteNode(win->WindowList)
  
  'Grafikpuffer des Windows aus entsprechender sGUIListe entfernen
  if win->DrawBuffer then
    owner=win->DrawBuffer->owner
    owner->DeleteNode(win->DrawBuffer)
  end if  
  
  'UserGFXpuffer des Windows aus entsprechender sGUIListe entfernen
  if win->UserGFXBuffer then
    owner=win->UserGFXBuffer->owner
    owner->DeleteNode(win->UserGFXBuffer)
  end if  
 
  'zum Schlu Fenster selbst aus entsprechender sGUIListe entfernen
  owner=win->owner
  owner->DeleteNode(win)
end sub


sub KillGadget (gad as _Gadget ptr)
  dim as sGUIList ptr owner
  'zuerst alle Objekte lschen die zwar von diesem Gadget benutzt, jedoch in einer entsprechenden sGUIListe verwaltet werden
  
  'hat dieses Gadget ein Fenster?
  if gad->GadgetWindow then KillWindow(gad->GadgetWindow)' eigene Lschroutine, siehe hier drber :)
 
  'Grafikpuffer des Gadgets aus entsprechender sGUIListe entfernen
  if gad->DrawBuffer then
    owner=gad->DrawBuffer->owner
    owner->DeleteNode(gad->DrawBuffer)
  end if
    
  'weitere/andere Elemente???? hier einfgen
  '.....
  
  'zum Schlu Gadget selbst aus entsprechender sGUIListe entfernen
  owner=gad->owner
  owner->DeleteNode(gad)
end sub


function GetUserImage (win as _sGUIWindow ptr=0) as FB.Image ptr
  function=0 
  if (win<>0) and (win<>RootWindow) then
    if (win->WinFlags and WFLAG_IMAGE) then
      function=win->DrawBuffer->img
    else
      if win->UserGFXBuffer->img=0 then win->UserGFXBuffer->img=imagecreate(win->ContentWidth,win->ContentHeight,Colors.Cleaning)  
      function=win->UserGFXBuffer->img
    end if
  end if
end function


'******************************************************************************
'******************************************************************************
'******************************************************************************
function DrawRequest (gad as _Gadget ptr) as integer
  function=gad->ReDraw
  gad->ReDraw=0
end function


sub UpdateGadget(gad as _Gadget ptr)
  dim as integer flgs  
  'rechte niedrige Bits ....0000HSAA
  flgs=(gad->MouseHover shl 3) or (gad->Selection shl 2) or (gad->Activation)
  '
  if flgs<>gad->oldFlags then
    gad->ReDraw=1
    gad->oldFlags=flgs
  end if  
  gad->DoUpdate(gad)'falls vorhanden, zustzliche gadgetspezifische Updates
end sub


sub GadgetOn (gad as Gadget ptr)
  ModifyActivation(gad,ACTIVATION_ON)
end sub


sub GadgetSleep (gad as Gadget ptr)
  ModifyActivation(gad,ACTIVATION_SLEEP)
end sub


sub GadgetOff (gad as Gadget ptr)
  ModifyActivation(gad,ACTIVATION_OFF)
end sub


sub RestoreActivation (gad as Gadget ptr)
  dim oa as integer=gad->Activation_Old
  select case oa
    case ACTIVATION_OFF
      GadgetOff (gad)
    case ACTIVATION_OFF
      GadgetOn (gad)
    case ACTIVATION_SLEEP
      GadgetSleep (gad)
  end select
end sub


sub ModifyActivation (gad as _Gadget ptr, mode as integer=ACTIVATION_OFF)
  dim as _Gadget ptr childgad
  'rekursiver Aufruf falls es ein GadgetWindow gibt
  select case mode
    case ACTIVATION_OFF
      gad->Activation_Old=gad->Activation'alten Zustand merken
      gad->Activation=ACTIVATION_OFF   
      'wenn Gadget ein Fenster enthlt
      if gad->GadgetWindow then
        childgad=gad->GadgetWindow->GadgetList->GetFirst
        if childgad then
          do
            ModifyActivation(childgad,ACTIVATION_OFF)
            childgad=cast(Gadget ptr,childgad->next_node)
          loop until childgad=0
        end if
      end if  
  
    case ACTIVATION_ON
      'if gad->Background=0 then gad->SaveBackGround
      gad->Activation_Old=gad->Activation'alten Zustand merken
      gad->Activation=ACTIVATION_ON    
      'wenn Gadget ein Fenster enthlt
      if gad->GadgetWindow then
        childgad=gad->GadgetWindow->GadgetList->GetFirst
        if childgad then
          do
            ModifyActivation(childgad,ACTIVATION_ON)
            childgad=cast(Gadget ptr,childgad->next_node)
          loop until childgad=0
        end if
      end if
      
    case ACTIVATION_SLEEP
      'if gad->Background=0 then gad->SaveBackGround
      gad->Activation_Old=gad->Activation'alten Zustand merken
      gad->Activation=ACTIVATION_SLEEP   
      'wenn Gadget ein Fenster enthlt
      if gad->GadgetWindow then
        childgad=gad->GadgetWindow->GadgetList->GetFirst
        if childgad then
          do
            ModifyActivation(childgad,ACTIVATION_SLEEP)
            childgad=cast(Gadget ptr,childgad->next_node)
          loop until childgad=0
        end if
      end if      
  end select    
end sub


function GetSelect (gad as _Gadget ptr) as integer
  function=gad->Selection
end function


sub SetSelect (gad as _Gadget ptr,Selection as integer=1)
  gad->Selection=Selection
end sub


'******************************************************************************
'*****************************************************************************
'*****************************************************************************
sub ShowWindow    (win as _sGUIWindow ptr)
  win->ActiveSince=timer
  win->Activation=1 
end sub


sub HideWindow    (win as _sGUIWindow ptr)
  win->Activation=0
end sub


sub DeleteWindow  (win as _sGUIWindow ptr)
  win->Activation=0
  KillWindow (win)
end sub


sub GetGlobalPosition(entity as any ptr, byref PosX as integer, byref PosY as integer)
  dim as _WinGadHeader ptr wgheader
  dim as any ptr parent
  wgheader=cast(_WinGadHeader ptr, entity)
  PosX +=wgheader->PosX
  PosY +=wgheader->PosY  
  if wgheader->KindOfType=0 then'bei einem Fenster, ContentOffsets hinzufgen
    PosX +=cast(sGUIWindow ptr, wgheader)->ContentOffsetX
    PosY +=cast(sGUIWindow ptr, wgheader)->ContentOffsetY
  end if
  parent=wgheader->parent  
  if parent then GetGlobalPosition(parent,PosX,PosY)
end sub
