#include once "Gadget_CloseButton.bas"
#include once "Gadget_DragBar.bas"
#include once "Gadget_Label.bas"
namespace sGUI

declare function AddWindow (parent as any ptr,PosX as integer,PosY as integer,WinWidth as integer,WinHeight as integer,Text as string="", WinFlags as integer=0, WinMenu as sGUIList ptr=0) as sGUIWindow ptr
declare function AddRootWindow as sGUIWindow ptr
declare function AddSimpleWarnWindow (PosX as integer,PosY as integer,Text as string) as sGUIWindow ptr


declare sub ClearWin (win as sGUIWindow ptr)
declare sub DrawWin (win as sGUIWindow ptr)

declare sub ValidateFlags(byref Flags as uinteger,Text as string="")
declare sub MoveWindowOnTop (win as _sGUIWindow ptr)

function AddWindow (parent as any ptr,PosX as integer,PosY as integer,WinWidth as integer,WinHeight as integer,Text as string="", WinFlags as integer=0, WinMenu as sGUIList ptr=0) as sGUIWindow ptr
  function=0
  dim as integer BarHeight,DragBarWidth,offsetx
  
  if parent=0 then parent=RootWindow
  dim as sGUIWindow ptr win
  dim as Gadget ptr closebutton,dragbar

  ValidateFlags(WinFlags,Text)  
  
  BarHeight=GetFontHeight + 2*LeastGap
  
  if cast(WinGadHeader ptr,parent)->KindOfType=0 then'falls zu erzeugendes Fenster ein child eines Fensters ist
    win=cast(sGUIWindow ptr,parent)->WindowList->AppendNew(sGUIWindowType)
  else                                               'falls zu erzeugendes Fenster ein child eines Gadgets ist
    win=GadgetWindowList->AppendNew(sGUIWindowType)
    if win then cast(Gadget ptr,parent)->GadgetWindow=win
  end if
  if win then
    win->Created=timer
    win->parent=parent
    win->Selection=0
    win->Activation=0
    win->PosX=PosX
    win->PosY=PosY
    win->Text=Text
    win->WinFlags=WinFlags
    
    'Contentbereich ist immer so gro wie bergebene Parameter
    'und befindet sich links oben, kein Versatz
    win->ContentWidth=WinWidth
    win->ContentHeight=WinHeight    
    win->ContentOffsetX=0
    win->ContentOffsetY=0
    'Fenstergre entspricht auch erstmal den bergebenen Parametern
    win->WinWidth=WinWidth
    win->WinHeight=WinHeight      

    'kann aber bei entsprechenden Flags "wachsen"...
'WFLAG_FRAMED    
    if (win->WinFlags and WFLAG_FRAMED) then
      'Fenster um zwei Randdicken vergrern
      win->WinWidth +=2*LeastGap 
      win->WinHeight +=2*LeastGap       
      'Content um eine Randbreite nach unten und rechts verschieben
      win->ContentOffsetX +=LeastGap
      win->ContentOffsetY +=LeastGap     
    end if

'WFLAG_TITLEBAR    
    if (win->WinFlags and WFLAG_TITLEBAR) then
      if win->WinHeight > win->ContentHeight then'falls ringsherum Rand schon hinzugefgt,dann
        win->WinHeight -=LeastGap'oberen Rand wieder entfernen 
        win->ContentOffsetY -=LeastGap'Content wieder nach oben schieben 
      end if
      win->WinHeight +=BarHeight'Hhe um Titelbalkendicke erhhen
      win->ContentOffsetY +=BarHeight'Content um eine Titelbalkendicke nach unten verschieben
    end if

'WFLAG_MENUBAR    
    if (win->WinFlags and WFLAG_MENUBAR) then
      win->WinHeight += BarHeight'Fensterhhe vergrert sich um eine Bar-Hhe  
      win->ContentOffsetY +=BarHeight'Content um Bar-Hhe nach unten verschieben     
    end if  
    
'WFLAG_IMAGE    
    if (win->WinFlags and WFLAG_IMAGE) then
    
    end if

'bis hierher mssen alle Grenvernderungen erledigt sein!
'***********************************************************

'WFLAG_CLOSEABLE / WFLAG_DRAGABLE
    if (win->WinFlags and WFLAG_TITLEBAR) then
      'Koordinaten der SystemGadgets sind immer relativ zur Position des ContentOffsets(!)
      'Darum sieht die Verortung der SystemGadgets etwas verwirrend aus
      'Urschlich ist die Funktion GetGlobalPosition.
      
      if ((win->WinFlags and WFLAG_CLOSEABLE)<>0) or ((win->WinFlags and WFLAG_DRAGABLE)<>0) then
        DragBarWidth=win->WinWidth'zuerst nehmen wir immer mal an, das Dragbar "fllt" die gesamte Fensterbreite aus     
        
        if win->WinWidth > win->ContentWidth then offsetx=-LeastGap else offsetx=0
      
        if (win->WinFlags and WFLAG_CLOSEABLE) then
          closebutton=AddCloseButton(win,offsetx,-win->ContentOffsetY)
          GadgetOn(closebutton)
          offsetx       +=BarHeight   
          DragBarWidth  -=BarHeight        
        end if      
      
        if (win->WinFlags and WFLAG_DRAGABLE) then        
          dragbar=AddDragBar(win,offsetx,-win->ContentOffsetY,DragBarWidth)
          GadgetOn(dragbar)
        end if      
      end if
    end if
     
    'im Falle eines Backdrop Fensters verschieben wir dieses an den Anfang
    if (win->WinFlags and WFLAG_BACKDROP) then cast(sGUIWindow ptr,parent)->WindowList->MoveToFirst(win)
    
    win->DrawBuffer->img=imagecreate(win->WinWidth,win->WinHeight)
    
    win->DoClearWindow =@ClearWin
    win->DoDrawWindow =@DrawWin 
    function=win
  end if 
end function


function AddRootWindow as sGUIWindow ptr
  function=0
	dim as sGUIWindow ptr win

  'alternative Erzeugung um das Rootwindow zum Bestandteil der WindowLists zu machen
  '!!! im MainDestructor das separate Lschen des RootWindows auskommentieren
  'das sollte nun ber das Lschen der WindowsLists passieren
  dim as sGUIList ptr winlist
  winlist  = WindowLists->AppendNew(sGUIListType)'eine Fensterliste an
  if winlist then
    win=winlist->AppendNew(sGUIWindowType)
    if win then
      win->Created=timer
      win->PosX=0
      win->PosY=0
      win->WinWidth=ScrnWidth
      win->WinHeight=ScrnHeight
      win->ContentOffsetX=0
      win->ContentOffsetY=0
      win->ContentWidth=ScrnWidth
      win->ContentHeight=ScrnHeight
      win->Activation=1      
      win->DrawBuffer->img=imagecreate(ScrnWidth,ScrnHeight)
      win->DoClearWindow =@ClearWin
      win->DoDrawWindow =@FakeWin
      function=win    
    end if
  end if
end function


function AddSimpleWarnWindow (PosX as integer,PosY as integer,Text as string) as sGUIWindow ptr
  function=0  
  dim as integer winWidth,winHeight
  dim as sGUIWindow ptr win
  dim as Gadget ptr lbl

  winWidth=GetTextWidth(Text) + 3*GetFontHeight
  winHeight=3*GetFontHeight
  win=AddWindow(0,PosX,PosY,winWidth,winHeight,,WFLAG_FRAMED or WFLAG_HIDECLICKEDINSIDE or WFLAG_HIDECLICKEDOUTSIDE or WFLAG_WARN)
  if win then
    lbl=AddLabel(win,GetFontHeight,GetFontHeight,Text)
    GadgetOn(lbl)
    function=win
  end if
end function



sub ClearWin (win as sGUIWindow ptr)
  if win=RootWindow then
    ClearBox win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight    
  else
    if not (win->WinFlags and WFLAG_IMAGE) then
      ClearBox win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight,Colors.BackGround   
      if win->UserGFXBuffer->img then put win->DrawBuffer->img,(win->ContentOffsetX,win->ContentOffsetY),win->UserGFXBuffer->img,pset   
    end if
  end if
end sub


sub DrawWin (win as sGUIWindow ptr)
  dim as integer TextPosX =int((win->WinWidth-GetTextWidth(win->Text))/2) 
  dim as integer BarHeight=GetFontHeight + 2*LeastGap
  dim as integer displayedSelection=win->Selection  
  
  displayedSelection=win->Selection 
  if (win->WinFlags and WFLAG_APPEARSSELECTED) then displayedSelection=1
  if (win->WinFlags and WFLAG_APPEARSUNSELECTED) then displayedSelection=0   
  
  if win->Activation then

    if (win->WinFlags and WFLAG_FRAMED) then
      if ((win->WinFlags and (WFLAG_APPEARSUNSELECTED or WFLAG_APPEARSSELECTED))=0) then
        WinFrame win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight,win->Selection             
      elseif (win->WinFlags and WFLAG_APPEARSSELECTED) then
        WinFrame win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight,1		
      elseif (win->WinFlags and WFLAG_APPEARSUNSELECTED) then
        WinFrame win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight,0       
      end if   
    end if
    
    if (win->WinFlags and WFLAG_TITLEBAR) then
  
      if displayedSelection then
        StdFilledBox win->DrawBuffer->img,0,0,win->WinWidth,BarHeight,Colors.WinFrame
        drawstring (win->DrawBuffer->img, TextPosX, LeastGap, win->Text,Colors.WinText)		          
      else
        StdFilledBox win->DrawBuffer->img,0,0,win->WinWidth,BarHeight,Colors.WinFrameUnselected
        drawstring (win->DrawBuffer->img, TextPosX, LeastGap, win->Text,Colors.WinTextUnselected)		        
      end if      
      
      /'  
      if ((win->WinFlags and (WFLAG_APPEARSUNSELECTED or WFLAG_APPEARSSELECTED))=0) then
        
        if win->Selection then
          StdFilledBox win->DrawBuffer->img,0,0,win->WinWidth,BarHeight,Colors.WinFrame        
        else
          StdFilledBox win->DrawBuffer->img,0,0,win->WinWidth,BarHeight,Colors.WinFrameUnselected
        end if
        
      elseif (win->WinFlags and WFLAG_APPEARSSELECTED) then
        StdFilledBox win->DrawBuffer->img,0,0,win->WinWidth,BarHeight,Colors.WinFrame			
      elseif (win->WinFlags and WFLAG_APPEARSUNSELECTED) then
        StdFilledBox win->DrawBuffer->img,0,0,win->WinWidth,BarHeight,Colors.WinFrameUnselected         
      end if        
            
      if displayedSelection then
        StdFilledBox win->DrawBuffer->img,0,0,win->WinWidth,BarHeight,Colors.WinFrame
        drawstring (win->DrawBuffer->img, TextPosX, LeastGap, win->Text,Colors.WinText)		          
      else
        StdFilledBox win->DrawBuffer->img,0,0,win->WinWidth,BarHeight,Colors.WinFrameUnselected
        drawstring (win->DrawBuffer->img, TextPosX, LeastGap, win->Text,Colors.WinTextUnselected)		        
      end if
      '/
    end if

    if (win->WinFlags and WFLAG_MENUBAR) then
      FilledBoxDrop win->DrawBuffer->img,win->ContentOffsetX,win->ContentOffsetY-BarHeight,win->ContentWidth,BarHeight,Colors.GadBody,,0,0
    end if
    
    if (win->WinFlags and WFLAG_IMAGE) then
    
    end if
    
  end if
end sub



sub ValidateFlags(byref Flags as uinteger,Text as string="")
  dim as uinteger mask,wintype,ButtonMenuFlags,GFXComponents,ImageFlag,StackFlags,SelectionFlags,AppearanceFlags,ragpicker
    
  mask= WFLAG_WINDOWMENU or WFLAG_DRAGABLE or WFLAG_CLOSEABLE or WFLAG_MINIMISABLE
  ButtonMenuFlags=(Flags and mask)  
  if Text<>""                      then GFXComponents = GFXComponents or WFLAG_TITLEBAR
  if (Flags and WFLAG_WINDOWMENU)  then GFXComponents = GFXComponents or WFLAG_MENUBAR
  if (Flags and WFLAG_DRAGABLE)    then GFXComponents = GFXComponents or WFLAG_TITLEBAR
  if (Flags and WFLAG_CLOSEABLE)   then GFXComponents = GFXComponents or WFLAG_TITLEBAR
  'if (Flags and WFLAG_MINIMISABLE)   then GFXComponents = GFXComponents or WFLAG_TITLEBAR
  
  'Durch Text,Buttons und Men sind bestimmte GFXElemente "zwangseingeschaltet" worden
  'Falls jedoch noch nicht angeschaltete GFXElemente "gewnscht" waren, jetzt verknpfen:
  mask=WFLAG_FRAMED or WFLAG_TITLEBAR or WFLAG_MENUBAR
  GFXComponents = GFXComponents or (Flags and mask) 
 
  'das WFLAG_IMAGE schliesst alle GFXElemente und Buttons und Men von oben aus
  if (Flags and WFLAG_IMAGE) then 
    wintype=WFLAG_IMAGE
    GFXComponents=0
    ButtonMenuFlags=0  
  end if
  
  'Stack Handle
  mask= WFLAG_STACKABLE or WFLAG_BACKDROP or WFLAG_ALWAYSONTOP or WFLAG_WARN or WFLAG_WARNIGNORE
  StackFlags=(Flags and mask)
  'falls mehrere oder kein StackFlag gesetzt wurde gilt WFLAG_STACKABLE als Vorgabe      
  if GetNumBits(StackFlags)<>1 then StackFlags=WFLAG_STACKABLE
  
  'Selection
  mask= WFLAG_PARENTSELECT or WFLAG_NOSELECT
  SelectionFlags=(Flags and mask)
  'falls mehrere Flags gesetzt wurden gilt 0 (kein gesetztes Flag) als Vorgabe      
  if GetNumBits(SelectionFlags)>1 then SelectionFlags=0 
  
  'Appearance
  mask= WFLAG_APPEARSSELECTED or WFLAG_APPEARSUNSELECTED
  AppearanceFlags=(Flags and mask)
  'falls mehrere Flags gesetzt wurden gilt 0 (kein gesetztes Flag) als Vorgabe      
  if GetNumBits(AppearanceFlags)>1 then AppearanceFlags=0
    
  'FlagSammler
  'bernahme der restlichen Flags aus dem "Original" 
  'derzeitig gibt es 20 Flags  
  mask=WFLAG_HIDECLICKEDOUTSIDE or WFLAG_HIDECLICKEDINSIDE or WFLAG_DELETEONCLOSE
  ragpicker=(Flags and mask)
  
  'zum Schluss wieder alles zusammenschrauben und das Original "berschreiben":
  Flags=wintype or ButtonMenuFlags or GFXComponents or StackFlags or AppearanceFlags or SelectionFlags or ragpicker
end sub


sub MoveWindowOnTop (win as _sGUIWindow ptr)
  dim as _sGUIWindow ptr parentwin
  parentwin=cast(sGUIWindow ptr, win->parent)
  'Memberroutine der sGUIList aufrufen:
  '->MoveToLast(ans Ende der Liste) bedeutet (als Fensterstapel interpretiert) ganz nach oben
  cast(sGUIList ptr,parentwin->WindowList)->MoveToLast(win)
end sub


end namespace


